/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20170709

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 20 "pic.y"
#include "pic.h"
#include "ptable.h"
#include "object.h"

extern int delim_flag;
extern void copy_rest_thru(const char *, const char *);
extern void copy_file_thru(const char *, const char *, const char *);
extern void push_body(const char *);
extern void do_for(char *var, double from, double to,
		   int by_is_multiplicative, double by, char *body);
extern void do_lookahead();

/* Maximum number of characters produced by printf("%g") */
#define GDIGITS 14

int yylex();
void yyerror(const char *);

void reset(const char *nm);
void reset_all();

place *lookup_label(const char *);
void define_label(const char *label, const place *pl);

direction current_direction;
position current_position;

implement_ptable(place)

PTABLE(place) top_table;

PTABLE(place) *current_table = &top_table;
saved_state *current_saved_state = 0;

object_list olist;

const char *ordinal_postfix(int n);
const char *object_type_name(object_type type);
char *format_number(const char *form, double n);
char *do_sprintf(const char *form, const double *v, int nv);

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 65 "pic.y"
typedef union {
	char *str;
	int n;
	double x;
	struct { double x, y; } pair;
	struct { double x; char *body; } if_data;
	struct { char *str; const char *filename; int lineno; } lstr;
	struct { double *v; int nv; int maxv; } dv;
	struct { double val; int is_multiplicative; } by;
	place pl;
	object *obj;
	corner crn;
	path *pth;
	object_spec *spec;
	saved_state *pstate;
	graphics_state state;
	object_type obtype;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 89 "pic.cpp"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define LABEL 257
#define VARIABLE 258
#define NUMBER 259
#define TEXT 260
#define COMMAND_LINE 261
#define DELIMITED 262
#define ORDINAL 263
#define TH 264
#define LEFT_ARROW_HEAD 265
#define RIGHT_ARROW_HEAD 266
#define DOUBLE_ARROW_HEAD 267
#define LAST 268
#define BOX 269
#define CIRCLE 270
#define ELLIPSE 271
#define ARC 272
#define LINE 273
#define ARROW 274
#define MOVE 275
#define SPLINE 276
#define HEIGHT 277
#define RADIUS 278
#define FIGNAME 279
#define WIDTH 280
#define DIAMETER 281
#define UP 282
#define DOWN 283
#define RIGHT 284
#define LEFT 285
#define FROM 286
#define TO 287
#define AT 288
#define WITH 289
#define BY 290
#define THEN 291
#define SOLID 292
#define DOTTED 293
#define DASHED 294
#define CHOP 295
#define SAME 296
#define INVISIBLE 297
#define LJUST 298
#define RJUST 299
#define ABOVE 300
#define BELOW 301
#define OF 302
#define THE 303
#define WAY 304
#define BETWEEN 305
#define AND 306
#define HERE 307
#define DOT_N 308
#define DOT_E 309
#define DOT_W 310
#define DOT_S 311
#define DOT_NE 312
#define DOT_SE 313
#define DOT_NW 314
#define DOT_SW 315
#define DOT_C 316
#define DOT_START 317
#define DOT_END 318
#define DOT_X 319
#define DOT_Y 320
#define DOT_HT 321
#define DOT_WID 322
#define DOT_RAD 323
#define SIN 324
#define COS 325
#define ATAN2 326
#define LOG 327
#define EXP 328
#define SQRT 329
#define K_MAX 330
#define K_MIN 331
#define INT 332
#define RAND 333
#define SRAND 334
#define COPY 335
#define THRU 336
#define TOP 337
#define BOTTOM 338
#define UPPER 339
#define LOWER 340
#define SH 341
#define PRINT 342
#define CW 343
#define CCW 344
#define FOR 345
#define DO 346
#define IF 347
#define ELSE 348
#define ANDAND 349
#define OROR 350
#define NOTEQUAL 351
#define EQUALEQUAL 352
#define LESSEQUAL 353
#define GREATEREQUAL 354
#define LEFT_CORNER 355
#define RIGHT_CORNER 356
#define NORTH 357
#define SOUTH 358
#define EAST 359
#define WEST 360
#define CENTER 361
#define END 362
#define START 363
#define RESET 364
#define UNTIL 365
#define PLOT 366
#define THICKNESS 367
#define FILL 368
#define COLORED 369
#define OUTLINED 370
#define SHADED 371
#define XSLANTED 372
#define YSLANTED 373
#define ALIGNED 374
#define SPRINTF 375
#define COMMAND 376
#define DEFINE 377
#define UNDEF 378
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,   18,   19,   19,   31,   31,   32,   32,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   34,
   33,   33,   35,   36,   33,   37,   38,   33,   39,   33,
   33,   40,   33,   33,   33,   25,   25,   41,   41,   41,
   29,   29,   30,   30,   30,   42,    9,   26,   26,    4,
    4,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    6,    6,    6,   17,   17,   17,   17,   43,   45,   17,
   17,   44,   44,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   46,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   20,   28,   28,   27,   27,   21,   21,
   21,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,   47,   47,    7,    7,   15,   15,   15,   15,   15,
   16,   16,   16,   24,   24,   23,   23,   10,   10,   22,
   22,   22,   22,   22,   22,   22,   22,   22,   13,   13,
   14,   14,   14,   12,   12,   12,   12,   12,   12,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,    1,    1,    2,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,
};
static const YYINT yylen[] = {                            2,
    1,    1,    3,    1,    3,    0,    1,    1,    2,    3,
    3,    4,    1,    1,    1,    1,    1,    2,    2,    0,
    3,    2,    0,    0,    7,    0,    0,    6,    0,   10,
    1,    0,    4,    1,    1,    1,    1,    2,    2,    3,
    1,    2,    1,    1,    1,    0,    5,    0,    2,    1,
    1,    3,    3,    3,    3,    3,    3,    3,    3,    2,
    0,    2,    3,    1,    4,    4,    4,    0,    0,    6,
    1,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    3,    0,    4,    3,    3,    3,    3,
    2,    2,    3,    2,    3,    2,    3,    2,    3,    3,
    3,    3,    3,    3,    3,    2,    2,    2,    3,    2,
    3,    2,    3,    3,    3,    3,    3,    3,    2,    3,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    3,    2,    1,    5,    0,    3,    1,    1,
    3,    1,    3,    5,    3,    5,    5,    5,    7,    6,
    8,    1,    4,    3,    3,    1,    2,    2,    3,    1,
    1,    1,    3,    1,    3,    1,    2,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    2,    1,    2,    3,
    1,    1,    2,    1,    5,    4,    3,    3,    2,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    2,    2,    2,    1,    1,
    2,    2,    2,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    1,    1,    2,    2,    2,    2,
    2,    3,    3,    3,    3,    3,    3,    2,    3,    4,
    4,    6,    4,    4,    4,    6,    6,    4,    4,    3,
    4,    3,    3,    3,    3,    3,    3,    3,    2,
};
static const YYINT yydefred[] = {                         0,
    8,    0,    2,    0,    0,    0,    0,  135,   17,   74,
   75,   76,   77,   78,   79,   80,   81,    0,   13,   14,
   16,   15,    0,   20,    0,    0,    0,    0,    0,    0,
    0,   85,   68,    0,    4,    0,    0,   82,   71,    0,
    9,    0,    0,    0,    0,    0,   26,    0,  161,  225,
  226,  164,  166,  204,  203,  160,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  201,  202,
    0,    0,  209,  210,  215,  216,  217,  218,  219,  221,
  220,    0,    0,    0,    0,    0,  222,    0,  142,  139,
  162,    0,    0,    0,    0,    0,    0,   44,    0,   41,
    0,    0,    0,    0,  223,    0,    0,    0,    0,   38,
    0,    0,    0,    0,    0,   32,    3,    0,  123,  124,
  125,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  106,  107,    0,    0,    0,  121,
  122,  129,  130,  131,  132,  126,  127,    0,    0,    0,
    0,    0,    0,    0,  134,    0,  128,   39,    0,    0,
   11,    0,   37,   36,   10,   23,    0,   21,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  207,
  205,  211,  213,  208,  206,  212,  214,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  227,  228,  229,
  230,  231,    0,  157,    0,    0,  178,  170,  171,  172,
  173,  174,  175,  176,    0,  169,  167,  168,   42,    0,
    0,   60,    0,    0,   46,    0,    0,    0,    0,   84,
  137,    0,    0,    0,    0,    5,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  103,    0,  184,    0,    0,    0,
  105,    0,    0,    0,    0,    0,  117,  118,  116,    0,
    0,   40,    0,    0,    0,    0,    0,    0,   65,    0,
   12,    0,   27,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  250,    0,    0,    0,    0,  239,  155,  141,
    0,    0,    0,  165,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  163,  143,  145,  177,    0,    0,   56,
    0,    0,    0,    0,   54,    0,    0,   53,   52,    0,
   86,   69,   33,  181,  189,    0,    0,    0,  179,    0,
    0,  183,    0,    0,   24,    0,  240,  241,    0,  243,
  244,  245,    0,    0,  248,  249,  251,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   47,    0,  136,    0,
    0,  188,  187,    0,  180,    0,    0,   28,    0,    0,
    0,    0,    0,  147,  144,  146,  153,    0,    0,    0,
    0,   73,   70,  186,    0,   25,   49,  242,  246,  247,
    0,    0,  150,    0,    0,  185,  149,    0,    0,    0,
   29,  151,    0,    0,   30,
};
static const YYINT yydgoto[] = {                          2,
  114,   97,  115,  200,  117,  445,   99,  100,   34,  101,
  102,  285,  286,  287,  118,  104,   35,    3,   36,   37,
  105,  246,  106,  107,  175,  418,  370,  119,  109,  110,
  263,    5,   39,   48,  312,  416,  177,  386,  454,  265,
   40,  363,  125,  433,  410,  124,  224,
};
static const YYINT yysindex[] = {                       -51,
    0,    0,    0, 5497,  -39,  -22,    7,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -28,    0,    0,
    0,    0, -258,    0,13586, -218,13670, -207,14172,   24,
13586,    0,    0, -276,    0,  -51,13165,    0,    0,  -43,
    0,  -51,13670,   28, -177, -231,    0, -168,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   57,   81,   88,
   97,  102,  128,  133,  180,  186,  187,  195,    0,    0,
 -185,    8,    0,    0,    0,    0,    0,    0,    0,    0,
    0,13835,13670,14172,14172, 1567,    0,   90,    0,    0,
    0,  -54,  167,  895,   12,  251,  897,    0,13586,    0,
  175,13670,13670,  349,    0,  -42, -196,  167, -192,    0,
    1,   -6,13586,  -51,  -51,    0,    0, 5035,    0,    0,
    0,14172,14172,14172,14172,14425,14425,14425,14425,14256,
14256,14256,14003,14341,    0,    0,14425,14425,14425,    0,
    0,    0,    0,    0,    0,    0,    0,14172,14425, -239,
 -239, -239,14172,14172,    0, 1688,    0,    0,   -3,12918,
    0,13670,    0,    0,    0,    0,   -5,    0,13670,13670,
13670,13670,13670,13670,13670,13670,13670,13284,13670,    0,
    0,    0,    0,    0,    0,    0,    0, 2031,  202,  225,
  227,  -38,   59,   23,  181,  181,  -27,    0,14172,14172,
14172,14172,14172,14172,14172,14172,14172,14172,14172,14172,
14172,14172,14172,14256,14256,   69,  242,    0,    0,    0,
    0,    0,   34,    0,14341,14341,    0,    0,    0,    0,
    0,    0,    0,    0,  210,    0,    0,    0,    0,14172,
  181,    0,13670,13670,    0,13670,13670, -239, -239,    0,
    0,  220, 5497,  170,   54,    0, 1688, 1688, 1688, 1688,
 1688, 1688, 1688, 1688, 1567,   12,   12,   12, 1819,  130,
  130,   67,13467,  -54,    0,  429,    0,   12,13919,  119,
    0, 1688, 1688, 1688, 1688, 1688,    0,    0,    0, 1688,
 1688,    0,  -22,    7,    0,    0,    0,  167,    0,   12,
    0,   65,    0,  290,  299,  315,  319,  333,  334,  340,
  341,  337,    0,  364,  366,14256,14256,    0,    0,    0,
14256,14341,14341,    0,   73, 1224,  -32,   -8,   -8,  437,
  437, 1688,  437,  437,  391,  391,  181,  181,  181,  181,
  -29,  104,  242,    0,    0,    0,    0,  778, 1224,    0,
  296,   61,  146, 1224,    0,  296,   61,    0,    0,   38,
    0,    0,    0,    0,    0,  251,  489,  489,    0,  369,
  159,    0, 1248,  227,    0,   53,    0,    0,13670,    0,
    0,    0,13670,13670,    0,    0,    0,  -20,  255,  324,
  379,  382,  121,14256,14256,14172,    0,14172,    0, 5497,
  489,    0,    0,  489,    0,   53,  171,    0,  386,  393,
  413,14256,14256,    0,    0,    0,    0,   12,  -21, 1676,
 1688,    0,    0,    0,  414,    0,    0,    0,    0,    0,
  327,   13,    0,14088,   96,    0,    0,  418,14172, 1688,
    0,    0, 1688,  198,    0,
};
static const YYINT yyrindex[] = {                       344,
    0,    0,    0,  462,  234,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  204,    0,    0,
    0,    0,    0,  328,    0,   27,  336,    0,    0,  528,
    0,13028,    0,    0,    0,  529,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,11191,    0,10778,    0,    0,
    0,    0, 4775,10342,11275,    0,    0,    0,  624,    0,
    0,    0,    0,  611,    0,    0, 1584,    0,    0,    0,
12546,    0,  657, 5961, 5961,    0,    0,  131,    0,    0,
    0,    0,    0,    0,    0,11639,11738,11386,11485,    0,
    0,    0,    0,    0,    0,    0,11892,11991,12145,    0,
    0,    0,    0,    0,    0,    0,    0,    0,12244,    0,
    0,    0,    0,    0,    0, 5358,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  422, 2495,    0,
  267,  304,    0,    0,  599,  718,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3383,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
10946,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 5703, 5822, 6167, 6286,
 6631, 6750, 7095, 7214,    0, 7559, 7678, 8023,10461, -242,
  205,    0,    0, 9997,    0,10889,    0, 8142,    0,    0,
    0, 8487, 8606, 8951, 9070, 9415,    0,    0,    0, 9534,
 9879,    0,12627, 2959, 3360, 3462,   47,   87,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 4311, 4430, 3502, 3847, 2455,
 2574, 5239, 2919, 3038, 1991, 2110, 1063, 1182, 1527, 1646,
    0,    0, 3966,    0,    0,    0,    0,    0,  373,    0,
  371,   32,    0, 3472,    0, 4400, 4864,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  422,    0,    0,  671,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  401,  405,    0,    0,    0,    0,    0,    0,    0,  810,
    0,    0,    0,    0,    0,  671,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 4894,    0,  135,
   52,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  439,    0,    0,    0,    0,    0,    0,  433,    0,  153,
    0,    0,  154,    0,    0,
};
static const YYINT yygindex[] = {                         0,
  -25,    0,   35,   58,   16,    0,  -18,  331,    0,    0,
 4126,    0,    0,   11,  110,  -83, -121,   98,    0,    0,
 1006,  -98,    0,    0,    0,  114,    0,   46,  481,  -78,
   17,  490,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  338,
};
#define YYTABLESIZE 14788
static const YYINT yytable[] = {                         96,
  169,   46,  330,  121,  222,   96,  266,    1,  248,  220,
  218,  166,  219,  235,  221,  236,    4,  164,  227,   41,
    8,  235,  235,  236,  236,  164,    6,  216,  222,  217,
  249,   59,   45,  220,  218,   42,  219,  222,  221,  111,
  443,   93,  220,  218,  249,  219,   66,  221,  309,   38,
  120,  216,  127,  217,  235,  235,  236,  236,  170,   98,
  216,  223,  217,  122,   44,   98,  198,   43,  205,  206,
  108,  126,   59,  201,  448,   59,  108,   47,  409,  173,
  174,  408,  167,   96,  116,  223,   67,  251,  172,  139,
   59,  139,  138,  178,  223,  138,  179,   96,  190,  191,
  171,  332,  331,  333,  176,   66,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  275,  275,  275,  290,    6,
  180,  292,  293,  294,   59,  291,  199,  181,  252,  140,
    7,  140,  295,  296,  103,   30,  182,  300,  301,   66,
  103,  183,  353,   98,  275,   67,  235,  405,  236,  225,
  204,    6,  256,  257,  108,  222,   59,   98,  258,  259,
  220,  218,  215,  219,   93,  221,  260,  184,  108,  192,
  193,   66,  185,   38,   98,   98,   98,   98,  216,   67,
  217,  377,  378,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  275,  275,
  227,  202,   49,   35,   98,  297,  298,  299,   52,  290,
  290,   67,  223,   53,  168,   38,  355,  356,  103,  186,
  245,  262,  264,    7,  358,  187,  188,  359,  361,  311,
  364,  366,  103,    7,  189,  250,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  324,  325,  226,  255,  103,
  103,  103,  103,  261,  302,    7,  313,  198,   98,   98,
    8,  327,   35,  383,  201,  328,    7,  329,  360,  362,
  384,  365,  367,    7,  223,  335,  404,  411,    7,  308,
  228,  229,  230,  231,  232,  422,  334,  233,  432,  375,
  354,  194,  195,  380,  372,   59,   35,  235,  423,  236,
  275,  275,  357,  368,  369,  275,  290,  290,   38,  142,
  142,  142,  371,  401,  402,  373,  209,  199,  211,  212,
  213,  214,   59,  379,    7,   49,  385,   31,   35,    7,
  387,   52,  222,  103,  103,   64,   53,  220,  218,  388,
  219,  245,  221,    6,  213,  214,  140,  140,  140,  209,
  210,  211,  212,  213,  214,  216,    7,  217,  389,  390,
   98,   98,  196,  197,  424,   98,  235,  447,  236,  235,
  258,  236,  257,  391,  392,   30,  403,  395,  275,  275,
  430,   59,  431,  393,  394,  222,   31,  412,  413,  223,
  220,  218,  202,  219,   64,  221,  275,  275,  238,  239,
  240,  241,  242,  243,  396,  244,  397,  407,  216,  256,
  217,  258,  414,  257,  258,  415,  257,  417,  450,  425,
   31,  434,  426,  453,  435,  427,  438,  222,   64,  258,
  437,  257,  220,  439,    6,  103,  103,  221,   98,   98,
  103,  451,  223,  143,  143,  143,  419,  145,  145,  145,
  420,  421,   31,  440,  446,   38,   98,   98,  452,  455,
   64,    1,   50,  258,  166,  257,    6,  209,  210,  211,
  212,  213,  214,  222,  381,  150,  150,  150,  220,  218,
   61,  219,  148,  221,  223,  228,  229,  230,  231,  232,
    7,    7,    7,    7,    7,  258,    7,  257,   62,   63,
  307,    7,    7,    7,    7,    7,    7,    7,    7,    7,
  237,  123,    7,  103,  103,    7,    7,    7,    7,  238,
  239,  240,  241,  242,  243,  128,  244,   34,   22,  436,
  223,  103,  103,    0,  282,  326,    0,    0,    0,    0,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    0,    0,    0,    0,    0,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    0,
    7,    7,    7,    7,    7,    7,    0,    0,    7,    0,
    7,    0,    0,    0,    0,    0,   34,   22,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,  238,    7,
    6,    6,    0,    6,    6,    0,    0,    0,    7,    7,
   50,    0,    6,    6,    6,    6,    6,    6,    6,    6,
   34,   22,    6,   19,    0,    6,    6,    6,    6,    0,
    0,  238,    0,    0,  258,  238,  257,    0,  238,  238,
  238,  238,  238,  238,  253,  238,  211,  212,  213,  214,
    0,   50,   34,   22,   50,    0,   18,  238,  238,    0,
  238,  258,    0,  257,    0,    0,    0,    0,    0,   50,
   48,    0,  258,    0,  257,  258,    0,  257,    6,    0,
    0,    0,   19,    0,    6,    6,    0,    0,    6,    0,
    6,  238,    0,    0,  238,    0,    0,  253,  254,  211,
  212,  213,  214,   50,    0,    0,    0,    6,    0,    6,
    0,    0,   54,   55,    0,   18,   19,  259,    6,    6,
  258,  257,  257,  238,    0,    0,    0,    0,    0,   48,
    0,    0,    0,    0,    0,   50,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,    0,   19,   18,
  259,    0,    0,    0,  259,    0,    0,  259,  259,  259,
  259,  259,  259,   48,  259,   79,   80,   81,   82,    0,
    0,    0,   54,   55,    0,    0,  259,  259,    0,  259,
    0,   18,    0,   83,   84,   85,   86,   87,   88,   89,
   90,   91,    0,    0,    0,   48,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,    0,    0,   72,
  259,    0,    0,  259,  222,    0,    0,    0,    0,  220,
  218,    0,  219,    0,  221,   79,   80,   81,   82,    0,
    0,    0,    0,    0,    0,    0,    0,  216,    0,  217,
    0,    0,  259,   83,   84,   85,   86,   87,   88,   89,
   90,   91,    0,    0,    0,  238,  238,  238,  238,    0,
    0,  238,  238,  238,  238,  238,  238,    0,   72,    0,
    0,  223,    0,    0,   50,  238,  238,    0,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,   50,   72,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,    0,    0,    0,
    0,    0,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,    0,   72,  238,  238,  238,  238,    0,
  233,  238,  238,    0,  238,    0,    0,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,    0,    0,    0,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  259,  259,  259,  259,    0,    0,
  259,  259,  259,  259,  259,  259,    0,  245,    0,    0,
    0,    0,    0,    0,  259,  259,    0,  259,  259,  259,
  259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
  259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
    0,    0,  259,  259,  259,  259,  259,  259,  259,  259,
  259,  259,  259,  259,  259,  259,    0,    0,    0,    0,
    0,  259,  259,  259,  259,  259,  259,  259,  259,  259,
  259,  259,    0,    0,  259,  259,  259,  259,    0,    0,
  259,  259,  234,  259,  406,    0,  259,  259,  259,  259,
  259,  259,  259,  259,  259,  259,  259,  259,  259,  259,
  259,    0,    0,    0,  259,  259,  259,  259,  259,  259,
  259,  259,  259,    0,    0,  234,    0,  203,    0,  234,
    0,    0,  234,  234,  234,  234,  234,  234,    0,  234,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  234,  234,    0,  234,    0,  209,  210,  211,  212,
  213,  214,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  276,  277,  278,  288,    0,
    0,    0,    0,    0,    0,  234,  237,    0,  234,    0,
    0,    0,    0,    0,  247,  238,  239,  240,  241,  242,
  243,    0,  244,    0,    0,  310,    0,    0,    0,    0,
    0,  235,    0,    0,    0,    0,    0,  234,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,    0,  235,    0,    0,    0,  235,    0,
    0,  235,  235,  235,  235,  235,  235,    0,  235,  351,
  352,   79,   80,   81,   82,    0,    0,    0,    0,    0,
  235,  235,    0,  235,    0,    0,    0,    0,    0,   83,
   84,   85,   86,   87,   88,   89,   90,   91,    0,    0,
  222,    0,    0,    0,    0,  220,  218,    0,  219,    0,
  221,    0,    0,    0,  235,    0,    0,  235,    0,    0,
    0,    0,    0,  216,  222,  217,    0,    0,  203,  220,
  218,  215,  219,    0,  221,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  235,  216,    0,  217,
    0,    0,    0,    0,    0,    0,    0,  223,    0,  234,
  234,  234,  234,    0,    0,  234,  234,  234,  234,  234,
  234,  398,  399,    0,    0,    0,  400,    0,    0,  234,
  234,  223,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,    0,    0,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,    0,    0,    0,    0,    0,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,    0,    0,  234,
  234,  234,  234,    0,    0,  234,  234,    0,  234,  428,
  429,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,    0,  441,  442,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  235,  235,
  235,  235,    0,    0,  235,  235,  235,  235,  235,  235,
    0,    0,    0,    0,    0,    0,    0,    0,  235,  235,
    0,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,    0,    0,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
    0,    0,    0,    0,    0,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,    0,    0,  235,  235,
  235,  235,    0,    0,  235,  235,  236,  235,    0,    0,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,    0,    0,    0,  235,  235,
  235,  235,  235,  235,  235,  235,  235,    0,    0,  236,
    0,    0,    0,  236,    0,    0,  236,  236,  236,  236,
  236,  236,    0,  236,  211,  212,  213,  214,    0,    0,
    0,    0,    0,   51,    0,  236,  236,    0,  236,    0,
    0,    0,    0,    0,    0,    0,  253,  254,  211,  212,
  213,  214,    0,  222,    0,    0,    0,    0,  220,  218,
  215,  219,    0,  221,    0,    0,    0,    0,    0,  236,
    0,    0,  236,    0,   51,    0,  216,   51,  217,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   51,    0,    0,  237,    0,    0,    0,    0,
    0,  236,    0,    0,    0,    0,    0,    0,    0,    0,
  223,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   51,    0,  237,    0,
    0,    0,  237,    0,    0,  237,  237,  237,  237,  237,
  237,    0,  237,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  237,  237,    0,  237,   51,    0,
    0,    0,  222,    0,    0,    0,    0,  220,  218,    0,
  219,    0,  221,    0,  222,    0,    0,    0,    0,  220,
  218,    0,  219,    0,  221,  216,    0,  217,  237,    0,
    0,  237,    0,    0,    0,    0,    0,  216,    0,  217,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  223,
  237,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  223,    0,  236,  236,  236,  236,    0,    0,  236,
  236,  236,  236,  236,  236,    0,    0,    0,    0,    0,
    0,    0,    0,  236,  236,    0,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,    0,
    0,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,    0,    0,   51,    0,    0,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,    0,    0,  236,  236,  236,  236,    0,  207,  236,
  236,  208,  236,    0,   51,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
    0,    0,    0,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  237,  237,  237,  237,    0,    0,  237,  237,
  237,  237,  237,  237,    0,  209,  210,  211,  212,  213,
  214,    0,  237,  237,    0,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,    0,    0,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,    0,  444,    0,    0,    0,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
    0,    0,  237,  237,  237,  237,    0,    0,  237,  237,
  232,  237,    0,    0,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,    0,
    0,    0,  237,  237,  237,  237,  237,  237,  237,  237,
  237,    0,    0,  232,  209,  210,  211,  212,  213,  214,
  232,  232,    0,  232,  232,  232,  209,  210,  211,  212,
  213,  214,    0,    0,    0,    0,    0,    0,    0,  232,
  232,    0,  232,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  222,    0,    0,
    0,    0,  220,  218,  215,  219,    0,  221,    0,    0,
    0,    0,    0,  232,    0,    0,  232,    0,    0,    0,
  216,    0,  217,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,    0,  232,    0,    0,    0,    0,
    0,    0,    0,    0,  223,    0,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,    0,    0,    0,
    0,    0,  233,    0,    0,    0,    0,    0,    0,  233,
  233,    0,  233,  233,  233,   79,   80,   81,   82,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  233,  233,
    0,  233,    0,   83,   84,   85,   86,   87,   88,   89,
   90,   91,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  233,    0,    0,  233,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  233,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  232,  232,  232,
  232,    0,    0,  232,  232,  232,  232,  232,  232,    0,
    0,    0,    0,    0,    0,    0,    0,  232,  232,    0,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,    0,    0,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,    0,
    0,    0,    0,    0,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,    0,    0,  232,  232,  232,
  232,    0,  207,  232,  232,  208,  232,    0,    0,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,    0,    0,    0,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  233,  233,  233,  233,
    0,    0,  233,  233,  233,  233,  233,  233,    0,  253,
  254,  211,  212,  213,  214,    0,  233,  233,    0,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,    0,    0,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,    0,    0,
    0,    0,    0,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,    0,    0,  233,  233,  233,  233,
    0,    0,  233,  233,  252,  233,    0,    0,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,    0,    0,    0,  233,  233,  233,  233,
  233,  233,  233,  233,  233,    0,    0,  252,    0,    0,
    0,    0,    0,    0,  252,  252,    0,    0,  252,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  252,  252,    0,  252,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  223,    0,    0,    0,  223,  223,  223,  223,  223,
    0,  223,    0,    0,    0,    0,    0,  252,    0,    0,
  252,    0,    0,    0,    0,    0,  223,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  254,    0,    0,    0,    0,    0,  252,
    0,    0,    0,    0,    0,    0,    0,    0,  223,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  254,    0,    0,    0,
    0,    0,    0,  254,  254,    0,    0,  254,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  254,  254,    0,  254,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  254,    0,    0,  254,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  254,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  252,  252,  252,  252,    0,    0,  252,  252,  252,
  252,  252,  252,    0,    0,    0,    0,    0,    0,    0,
    0,  252,  252,    0,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,    0,    0,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,    0,    0,    0,    0,    0,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,    0,
    0,  252,  252,  252,  252,    0,  223,  252,  252,  223,
  252,    0,    0,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,    0,    0,
    0,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  254,  254,  254,  254,    0,    0,  254,  254,  254,  254,
  254,  254,    0,  223,  223,  223,  223,  223,  223,    0,
  254,  254,    0,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,    0,    0,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,    0,    0,    0,    0,    0,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,    0,    0,
  254,  254,  254,  254,    0,    0,  254,  254,  224,  254,
    0,    0,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,    0,    0,    0,
  254,  254,  254,  254,  254,  254,  254,  254,  254,    0,
    0,  224,    0,    0,    0,    0,    0,    0,  224,  224,
    0,    0,  224,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  224,  224,    0,
  224,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  225,    0,    0,    0,    0,
  225,  225,  225,  225,    0,  225,    0,    0,    0,    0,
    0,  224,    0,    0,  224,    0,    0,    0,  225,    0,
  225,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  253,    0,    0,
    0,    0,    0,  224,    0,    0,    0,    0,    0,    0,
    0,    0,  225,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  253,    0,    0,    0,    0,    0,    0,  253,  253,    0,
    0,  253,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,  253,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  253,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  253,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  224,  224,  224,  224,    0,
    0,  224,  224,  224,  224,  224,  224,    0,    0,    0,
    0,    0,    0,    0,    0,  224,  224,    0,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,    0,    0,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,    0,    0,    0,
    0,    0,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,    0,    0,  224,  224,  224,  224,    0,
  225,  224,  224,  225,  224,    0,    0,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,    0,    0,    0,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  253,  253,  253,  253,    0,    0,
  253,  253,  253,  253,  253,  253,    0,  225,  225,  225,
  225,  225,  225,    0,  253,  253,    0,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
    0,    0,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,    0,    0,    0,   16,
    0,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,    0,    0,  253,  253,  253,  253,    0,    0,
  253,  253,  158,  253,    0,    0,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,    0,    0,    0,  253,  253,  253,  253,  253,  253,
  253,  253,  253,    0,    0,  158,    0,    0,   16,    0,
    0,    0,  158,  158,    0,  158,  158,  158,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  158,    0,    0,  158,    0,    0,    0,    0,    0,
    0,    0,   16,    0,    0,  204,    0,    0,    0,    0,
    0,   15,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   55,    0,    0,    0,  158,    0,    0,  158,    0,
    0,    0,    0,    0,   16,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  256,    0,    0,    0,    0,    0,  158,    0,    0,
    0,    0,   55,    0,    0,   55,    0,    0,    0,    0,
   15,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   55,    0,    0,    0,  256,    0,    0,    0,    0,    0,
    0,  256,  256,    0,    0,  256,    0,    0,    0,    0,
    0,    0,    0,    0,   15,    0,    0,  203,    0,    0,
  256,    0,    0,    0,   55,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   15,    0,    0,    0,
    0,    0,    0,    0,  256,    0,   55,  256,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  204,    0,    0,    0,
    0,    0,  204,    0,    0,    0,  256,  204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  158,
  158,  158,  158,    0,    0,  158,    0,  158,  158,  158,
  158,    0,    0,    0,    0,    0,    0,    0,    0,  158,
  158,  204,  158,  158,  158,  158,  158,  158,  158,  158,
  158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
  158,  158,  158,  158,    0,    0,    0,    0,  158,  158,
  158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
  158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
  158,  158,  158,  158,  158,  158,  158,    0,  203,  158,
  158,  158,  158,    0,  203,  158,  158,    0,    0,  203,
    0,    0,    0,    0,    0,   55,    0,  158,  158,  158,
  158,  158,  158,  158,  158,  158,    0,    0,    0,  158,
  158,  158,  158,  158,  158,  158,  158,  158,  256,  256,
  256,  256,   55,  203,  256,  256,  256,  256,  256,  256,
    0,    0,    0,    0,    0,    0,    0,    0,  256,  256,
    0,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,    0,    0,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
   55,   55,    0,    0,    0,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,    0,    0,  256,  256,
  256,  256,    0,    0,  256,  256,  255,  256,    0,    0,
  256,  256,  256,  256,    0,    0,  256,  256,  256,  256,
  256,  256,  256,  256,  256,    0,    0,    0,  256,  256,
  256,  256,  256,  256,  256,  256,  256,    0,    0,  255,
    0,    0,    0,    0,    0,    0,  255,  255,    0,    0,
  255,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  255,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  255,
    0,    0,  255,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  159,    0,    0,    0,    0,
    0,  255,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  159,    0,
    0,    0,    0,    0,    0,  159,  159,    0,  159,  159,
  159,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  159,    0,    0,  159,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  159,    0,
    0,  159,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  159,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  255,  255,  255,  255,    0,    0,  255,
  255,  255,  255,  255,  255,    0,    0,    0,    0,    0,
    0,    0,    0,  255,  255,    0,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,    0,
    0,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,    0,    0,    0,    0,    0,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,    0,    0,  255,  255,  255,  255,    0,    0,  255,
  255,    0,  255,    0,    0,  255,  255,  255,  255,    0,
    0,  255,  255,  255,  255,  255,  255,  255,  255,  255,
    0,    0,    0,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  159,  159,  159,  159,    0,    0,  159,  234,
  159,  159,  159,  159,    0,    0,    0,    0,    0,    0,
    0,    0,  159,  159,    0,  159,  159,  159,  159,  159,
  159,  159,  159,  159,  159,  159,  159,  159,  159,  159,
  159,  159,  159,  159,  159,  159,  159,    0,  284,    0,
    0,  159,  159,  159,  159,  159,  159,  159,  159,  159,
  159,  159,  159,  159,  159,  159,  159,  159,  159,  159,
  159,  159,  159,  159,  159,  159,  159,  159,  159,  159,
    0,    0,  159,  159,  159,  159,    0,    0,  159,  159,
  257,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  159,  159,  159,  159,  159,  159,  159,  159,  159,    0,
    0,    0,  159,  159,  159,  159,  159,  159,  159,  159,
  159,    0,    0,  257,    0,    0,    0,    0,    0,    0,
  257,  257,    0,    0,  257,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  257,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   58,
    0,    0,    0,  257,  374,    0,  257,    0,  284,    0,
    0,  382,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  258,
    0,    0,    0,    0,    0,  257,    0,    0,    0,    0,
   58,    0,    0,   58,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,    0,
    0,    0,  258,    0,    0,    0,    0,    0,    0,  258,
  258,    0,    0,  258,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  258,    0,
    0,    0,   58,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  374,  374,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  258,    0,   58,  258,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  374,    0,    0,  374,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  258,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  257,  257,  257,
  257,    0,    0,  257,  257,  257,  257,  257,  257,    0,
    0,    0,    0,    0,    0,    0,    0,  257,  257,    0,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,    0,    0,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,    0,
    0,    0,    0,    0,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,    0,    0,  257,  257,  257,
  257,    0,    0,  257,  257,    0,  257,    0,    0,  257,
  257,    0,    0,   58,    0,  257,  257,  257,  257,  257,
  257,  257,  257,  257,    0,    0,    0,  257,  257,  257,
  257,  257,  257,  257,  257,  257,  258,  258,  258,  258,
   58,    0,  258,  258,  258,  258,  258,  258,    0,    0,
    0,    0,    0,    0,    0,    0,  258,  258,    0,  258,
  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
  258,  258,    0,    0,  258,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  258,  258,  258,    0,   58,
    0,    0,    0,  258,  258,  258,  258,  258,  258,  258,
  258,  258,  258,  258,    0,    0,  258,  258,  258,  258,
    0,    0,  258,  258,  140,  258,    0,    0,    0,  258,
    0,    0,    0,    0,  258,  258,  258,  258,  258,  258,
  258,  258,  258,    0,    0,    0,  258,  258,  258,  258,
  258,  258,  258,  258,  258,    0,    0,  140,    0,    0,
    0,    0,    0,    0,  140,  140,    0,  140,  140,  140,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  140,    0,    0,  140,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   57,    0,    0,    0,  140,    0,    0,
  140,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  148,    0,    0,    0,    0,    0,  140,
    0,    0,    0,    0,   57,    0,    0,   57,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   57,    0,    0,    0,  148,    0,    0,    0,
    0,    0,    0,  148,  148,    0,    0,  148,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  148,    0,    0,  148,   57,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  148,    0,   57,  148,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  148,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  140,  140,  140,  140,    0,    0,  140,    0,  140,
  140,  140,  140,    0,    0,    0,    0,    0,    0,    0,
    0,  140,  140,    0,  140,  140,  140,  140,  140,  140,
  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
  140,  140,  140,  140,  140,  140,    0,    0,    0,    0,
  140,  140,  140,  140,  140,  140,  140,  140,  140,  140,
  140,  140,  140,   41,    0,    0,    0,    0,  140,  140,
  140,  140,  140,  140,  140,  140,  140,  140,  140,    0,
    0,  140,  140,  140,  140,    0,    0,  140,  140,    0,
    0,    0,    0,    0,    0,   32,    0,   57,    0,  140,
  140,  140,  140,  140,  140,  140,  140,  140,    0,    0,
    0,  140,  140,  140,  140,  140,  140,  140,  140,  140,
  148,  148,  148,  148,   57,    0,  148,   33,  148,  148,
  148,  148,    0,    0,    0,    0,    0,    0,    0,    0,
  148,  148,    0,  148,  148,  148,  148,  148,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
  148,  148,  148,  148,  148,    0,    0,    0,    0,  148,
  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
  148,  148,    0,   57,    0,    0,    0,  148,  148,  148,
  148,  148,  148,  148,  148,  148,  148,  148,    0,    0,
  148,  148,  148,  148,    0,    0,  148,  148,  154,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  148,  148,
  148,  148,  148,  148,  148,  148,  148,    0,    0,    0,
  148,  148,  148,  148,  148,  148,  148,  148,  148,    0,
    0,  154,    0,    0,    0,    0,    0,    0,  154,  154,
    0,    0,  154,    0,    0,    0,    0,    0,    0,    0,
    0,    6,    7,    0,    8,    9,    0,  154,    0,    0,
    0,    0,    0,   10,   11,   12,   13,   14,   15,   16,
   17,    0,    0,   18,    0,    0,   19,   20,   21,   22,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  154,    0,    0,  154,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   91,    0,    0,
    0,    0,    0,  154,    0,    0,    0,    0,    0,   23,
    0,    0,    0,    0,    0,   24,   25,    0,    0,   26,
    0,   27,    0,    0,    0,    0,    0,    0,    0,    0,
   91,    0,    0,    0,    0,    0,    0,   91,   28,    0,
   29,    0,    0,    0,    0,    0,    0,    0,    0,   30,
   31,    0,    0,    0,    0,    0,   91,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   91,    0,    0,   91,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   91,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  154,  154,  154,  154,    0,
    0,  154,    0,  154,  154,  154,  154,    0,    0,    0,
    0,    0,    0,    0,    0,  154,  154,    0,  154,  154,
  154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
  154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
    0,    0,    0,    0,  154,  154,  154,  154,  154,  154,
  154,  154,  154,  154,  154,  154,  154,    0,    0,    0,
    0,    0,  154,  154,  154,  154,  154,  154,  154,  154,
  154,  154,  154,    0,    0,  154,  154,  154,  154,    0,
    0,  154,  154,    0,    0,    0,    0,   32,    0,    0,
    0,    0,    0,  154,  154,  154,  154,  154,  154,  154,
  154,  154,    0,    0,    0,  154,  154,  154,  154,  154,
  154,  154,  154,  154,   91,   91,   91,   91,    0,   33,
   91,    0,   91,   91,   91,   91,    0,    0,    0,    0,
    0,    0,    0,    0,   91,   91,    0,   91,   91,   91,
   91,   91,   91,   91,   91,   91,   91,   91,   91,   91,
   91,   91,   91,   91,   91,   91,   91,   91,   91,    0,
    0,    0,    0,    0,   91,   91,   91,   91,   91,   91,
   91,   91,   91,   91,   91,   91,    0,    0,    0,    0,
    0,   91,   91,   91,   91,   91,   91,   91,   91,   91,
   91,   91,    0,    0,   91,   91,   91,   91,    0,    0,
   91,   91,   87,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   91,   91,   91,   91,   91,   91,   91,   91,
   91,    0,    0,    0,   91,   91,   91,   91,   91,   91,
   91,   91,   91,    0,    0,   87,    0,    0,    0,    0,
    0,    0,   87,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    6,    7,    0,    8,    9,    0,    0,
    0,   87,    0,    0,    0,   10,   11,   12,   13,   14,
   15,   16,   17,    0,    0,   18,    0,    0,   19,   20,
   21,   22,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   87,    0,    0,   87,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   88,    0,    0,    0,    0,    0,   87,    0,    0,
    0,   23,    0,    0,    0,    0,    0,   24,   25,    0,
    0,   26,    0,   27,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   88,    0,    0,    0,    0,    0,
   28,   88,   29,    0,    0,    0,    0,    0,    0,    0,
    0,   30,   31,    0,    0,    0,    0,    0,    0,    0,
   88,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   88,    0,    0,   88,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   88,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   87,
   87,   87,   87,    0,    0,   87,    0,   87,   87,   87,
   87,    0,    0,    0,    0,    0,    0,    0,    0,   87,
   87,    0,   87,   87,   87,   87,   87,   87,   87,   87,
   87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
   87,   87,   87,   87,    0,    0,    0,    0,    0,   87,
   87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
   87,    0,    0,    0,    0,    0,   87,   87,   87,   87,
   87,   87,   87,   87,   87,   87,   87,    0,    0,   87,
   87,   87,   87,    0,    0,   87,   87,    0,    0,    0,
    0,    6,    0,    0,    0,    0,    0,   87,   87,   87,
   87,   87,   87,   87,   87,   87,    0,    0,    0,   87,
   87,   87,   87,   87,   87,   87,   87,   87,   88,   88,
   88,   88,    0,    6,   88,    0,   88,   88,   88,   88,
    0,    0,    0,    0,    0,    0,    0,    0,   88,   88,
    0,   88,   88,   88,   88,   88,   88,   88,   88,   88,
   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
   88,   88,   88,    0,    0,    0,    0,    0,   88,   88,
   88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
    0,    0,    0,    0,    0,   88,   88,   88,   88,   88,
   88,   88,   88,   88,   88,   88,    0,    0,   88,   88,
   88,   88,    0,    0,   88,   88,   89,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   88,   88,   88,   88,
   88,   88,   88,   88,   88,    0,    0,    0,   88,   88,
   88,   88,   88,   88,   88,   88,   88,    0,    0,   89,
    0,    0,    0,    0,    0,    0,   89,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    6,    6,    0,
    6,    6,    0,    0,    0,   89,    0,    0,    0,    6,
    6,    6,    6,    6,    6,    6,    6,    0,    0,    6,
    0,    0,    6,    6,    6,    6,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   89,
    0,    0,   89,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   90,    0,    0,    0,    0,
    0,   89,    0,    0,    0,    6,    0,    0,    0,    0,
    0,    6,    6,    0,    0,    6,    0,    6,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   90,    0,
    0,    0,    0,    0,    6,   90,    6,    0,    0,    0,
    0,    0,    0,    0,    0,    6,    6,    0,    0,    0,
    0,    0,    0,    0,   90,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   90,    0,
    0,   90,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   90,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   89,   89,   89,   89,    0,    0,   89,
    0,   89,   89,   89,   89,    0,    0,    0,    0,    0,
    0,    0,    0,   89,   89,    0,   89,   89,   89,   89,
   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
   89,   89,   89,   89,   89,   89,   89,   89,    0,    0,
    0,    0,    0,   89,   89,   89,   89,   89,   89,   89,
   89,   89,   89,   89,   89,    0,    0,    0,    0,    0,
   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
   89,    0,    0,   89,   89,   89,   89,    0,    0,   89,
   89,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   89,   89,   89,   89,   89,   89,   89,   89,   89,
    0,    0,    0,   89,   89,   89,   89,   89,   89,   89,
   89,   89,   90,   90,   90,   90,    0,    0,   90,    0,
   90,   90,   90,   90,    0,    0,    0,    0,    0,    0,
    0,    0,   90,   90,    0,   90,   90,   90,   90,   90,
   90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
   90,   90,   90,   90,   90,   90,   90,    0,    0,    0,
    0,    0,   90,   90,   90,   90,   90,   90,   90,   90,
   90,   90,   90,   90,    0,    0,    0,    0,    0,   90,
   90,   90,   90,   90,   90,   90,   90,   90,   90,   90,
    0,    0,   90,   90,   90,   90,    0,    0,   90,   90,
   93,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   90,   90,   90,   90,   90,   90,   90,   90,   90,    0,
    0,    0,   90,   90,   90,   90,   90,   90,   90,   90,
   90,    0,    0,   93,    0,    0,    0,    0,    0,    0,
   93,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   93,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   93,    0,    0,   93,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   95,
    0,    0,    0,    0,    0,   93,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   95,    0,    0,    0,    0,    0,    0,   95,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   95,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   95,    0,    0,   95,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   95,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   93,   93,   93,
   93,    0,    0,   93,    0,   93,   93,   93,   93,    0,
    0,    0,    0,    0,    0,    0,    0,   93,   93,    0,
   93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
   93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
   93,   93,    0,    0,    0,    0,    0,   93,   93,   93,
   93,   93,   93,   93,   93,   93,   93,   93,   93,    0,
    0,    0,    0,    0,   93,   93,   93,   93,   93,   93,
   93,   93,   93,   93,   93,    0,    0,   93,   93,   93,
   93,    0,    0,   93,   93,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   93,   93,   93,   93,   93,
   93,   93,   93,   93,    0,    0,    0,   93,   93,   93,
   93,   93,   93,   93,   93,   93,   95,   95,   95,   95,
    0,    0,   95,    0,   95,   95,   95,   95,    0,    0,
    0,    0,    0,    0,    0,    0,   95,   95,    0,   95,
   95,   95,   95,   95,   95,   95,   95,   95,   95,   95,
   95,   95,   95,   95,   95,   95,   95,   95,   95,   95,
   95,    0,    0,    0,    0,    0,   95,   95,   95,   95,
   95,   95,   95,   95,   95,   95,   95,   95,    0,    0,
    0,    0,    0,   95,   95,   95,   95,   95,   95,   95,
   95,   95,   95,   95,    0,    0,   95,   95,   95,   95,
    0,    0,   95,   95,   97,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   95,   95,   95,   95,   95,   95,
   95,   95,   95,    0,    0,    0,   95,   95,   95,   95,
   95,   95,   95,   95,   95,    0,    0,   97,    0,    0,
    0,    0,    0,    0,   97,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   97,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   97,    0,    0,
   97,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   99,    0,    0,    0,    0,    0,   97,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   99,    0,    0,    0,
    0,    0,    0,   99,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   99,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   99,    0,    0,   99,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   99,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   97,   97,   97,   97,    0,    0,   97,    0,   97,
   97,   97,   97,    0,    0,    0,    0,    0,    0,    0,
    0,   97,   97,    0,   97,   97,   97,   97,   97,   97,
   97,   97,   97,   97,   97,   97,   97,   97,   97,   97,
   97,   97,   97,   97,   97,   97,    0,    0,    0,    0,
    0,   97,   97,   97,   97,   97,   97,   97,   97,   97,
   97,   97,   97,    0,    0,    0,    0,    0,   97,   97,
   97,   97,   97,   97,   97,   97,   97,   97,   97,    0,
    0,   97,   97,   97,   97,    0,    0,   97,   97,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   97,
   97,   97,   97,   97,   97,   97,   97,   97,    0,    0,
    0,   97,   97,   97,   97,   97,   97,   97,   97,   97,
   99,   99,   99,   99,    0,    0,   99,    0,   99,   99,
   99,   99,    0,    0,    0,    0,    0,    0,    0,    0,
   99,   99,    0,   99,   99,   99,   99,   99,   99,   99,
   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
   99,   99,   99,   99,   99,    0,    0,    0,    0,    0,
   99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
   99,   99,    0,    0,    0,    0,    0,   99,   99,   99,
   99,   99,   99,   99,   99,   99,   99,   99,    0,    0,
   99,   99,   99,   99,    0,    0,   99,   99,  100,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   99,   99,
   99,   99,   99,   99,   99,   99,   99,    0,    0,    0,
   99,   99,   99,   99,   99,   99,   99,   99,   99,    0,
    0,  100,    0,    0,    0,    0,    0,    0,  100,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  100,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  100,    0,    0,  100,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  101,    0,    0,
    0,    0,    0,  100,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  101,    0,    0,    0,    0,    0,    0,  101,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  101,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  101,    0,    0,  101,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  101,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  100,  100,  100,  100,    0,
    0,  100,    0,  100,  100,  100,  100,    0,    0,    0,
    0,    0,    0,    0,    0,  100,  100,    0,  100,  100,
  100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
  100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
    0,    0,    0,    0,    0,  100,  100,  100,  100,  100,
  100,  100,  100,  100,  100,  100,  100,    0,    0,    0,
    0,    0,  100,  100,  100,  100,  100,  100,  100,  100,
  100,  100,  100,    0,    0,  100,  100,  100,  100,    0,
    0,  100,  100,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  100,  100,  100,  100,  100,  100,  100,
  100,  100,    0,    0,    0,  100,  100,  100,  100,  100,
  100,  100,  100,  100,  101,  101,  101,  101,    0,    0,
  101,    0,  101,  101,  101,  101,    0,    0,    0,    0,
    0,    0,    0,    0,  101,  101,    0,  101,  101,  101,
  101,  101,  101,  101,  101,  101,  101,  101,  101,  101,
  101,  101,  101,  101,  101,  101,  101,  101,  101,    0,
    0,    0,    0,    0,  101,  101,  101,  101,  101,  101,
  101,  101,  101,  101,  101,  101,    0,    0,    0,    0,
    0,  101,  101,  101,  101,  101,  101,  101,  101,  101,
  101,  101,    0,    0,  101,  101,  101,  101,    0,    0,
  101,  101,  102,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  101,  101,  101,  101,  101,  101,  101,  101,
  101,    0,    0,    0,  101,  101,  101,  101,  101,  101,
  101,  101,  101,    0,    0,  102,    0,    0,    0,    0,
    0,    0,  102,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  102,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  102,    0,    0,  102,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  104,    0,    0,    0,    0,    0,  102,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  104,    0,    0,    0,    0,    0,
    0,  104,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  104,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  104,    0,    0,  104,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  104,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  102,
  102,  102,  102,    0,    0,  102,    0,  102,  102,  102,
  102,    0,    0,    0,    0,    0,    0,    0,    0,  102,
  102,    0,  102,  102,  102,  102,  102,  102,  102,  102,
  102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
  102,  102,  102,  102,    0,    0,    0,    0,    0,  102,
  102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
  102,    0,    0,    0,    0,    0,  102,  102,  102,  102,
  102,  102,  102,  102,  102,  102,  102,    0,    0,  102,
  102,  102,  102,    0,    0,  102,  102,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  102,  102,  102,
  102,  102,  102,  102,  102,  102,    0,    0,    0,  102,
  102,  102,  102,  102,  102,  102,  102,  102,  104,  104,
  104,  104,    0,    0,  104,    0,  104,  104,  104,  104,
    0,    0,    0,    0,    0,    0,    0,    0,  104,  104,
    0,  104,  104,  104,  104,  104,  104,  104,  104,  104,
  104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
  104,  104,  104,    0,    0,    0,    0,    0,  104,  104,
  104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
    0,    0,    0,    0,    0,  104,  104,  104,  104,  104,
  104,  104,  104,  104,  104,  104,    0,    0,  104,  104,
  104,  104,    0,    0,  104,  104,  109,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  104,  104,  104,  104,
  104,  104,  104,  104,  104,    0,    0,    0,  104,  104,
  104,  104,  104,  104,  104,  104,  104,    0,    0,  109,
    0,    0,    0,    0,    0,    0,  109,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  109,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  109,
    0,    0,  109,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  111,    0,    0,    0,    0,
    0,  109,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  111,    0,
    0,    0,    0,    0,    0,  111,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  111,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  111,    0,
    0,  111,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  111,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  109,  109,  109,  109,    0,    0,  109,
    0,  109,  109,  109,  109,    0,    0,    0,    0,    0,
    0,    0,    0,  109,  109,    0,  109,  109,  109,  109,
  109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
  109,  109,  109,  109,  109,  109,  109,  109,    0,    0,
    0,    0,    0,  109,  109,  109,  109,  109,  109,  109,
  109,  109,  109,  109,  109,    0,    0,    0,    0,    0,
  109,  109,  109,  109,  109,  109,  109,  109,  109,  109,
  109,    0,    0,  109,  109,  109,  109,    0,    0,  109,
  109,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  109,  109,  109,  109,  109,  109,  109,  109,  109,
    0,    0,    0,  109,  109,  109,  109,  109,  109,  109,
  109,  109,  111,  111,  111,  111,    0,    0,  111,    0,
  111,  111,  111,  111,    0,    0,    0,    0,    0,    0,
    0,    0,  111,  111,    0,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  111,  111,  111,  111,    0,    0,    0,
    0,    0,  111,  111,  111,  111,  111,  111,  111,  111,
  111,  111,  111,  111,    0,    0,    0,    0,    0,  111,
  111,  111,  111,  111,  111,  111,  111,  111,  111,  111,
    0,    0,  111,  111,  111,  111,    0,    0,  111,  111,
  120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  111,  111,  111,  111,  111,  111,  111,  111,  111,    0,
    0,    0,  111,  111,  111,  111,  111,  111,  111,  111,
  111,    0,    0,  120,    0,    0,    0,    0,    0,    0,
  120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  120,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  120,    0,    0,  120,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  133,
    0,    0,    0,    0,    0,  120,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,    0,    0,    0,    0,    0,    0,  133,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  133,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,    0,    0,  133,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  120,  120,  120,
  120,    0,    0,  120,    0,  120,  120,  120,  120,    0,
    0,    0,    0,    0,    0,    0,    0,  120,  120,    0,
  120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
  120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
  120,  120,    0,    0,    0,    0,    0,  120,  120,  120,
  120,  120,  120,  120,  120,  120,  120,  120,  120,    0,
    0,    0,    0,    0,  120,  120,  120,  120,  120,  120,
  120,  120,  120,  120,  120,    0,    0,  120,  120,  120,
  120,    0,    0,  120,  120,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  120,  120,  120,  120,  120,
  120,  120,  120,  120,    0,    0,    0,  120,  120,  120,
  120,  120,  120,  120,  120,  120,  133,  133,  133,  133,
    0,    0,  133,    0,  133,  133,  133,  133,    0,    0,
    0,    0,    0,    0,    0,    0,  133,  133,    0,  133,
  133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
  133,  133,  133,  133,  133,  133,  133,  133,  133,  133,
  133,    0,    0,    0,    0,    0,  133,  133,  133,  133,
  133,  133,  133,  133,  133,  133,  133,  133,    0,    0,
    0,    0,    0,  133,  133,  133,  133,  133,  133,  133,
  133,  133,  133,  133,    0,    0,  133,  133,  133,  133,
    0,    0,  133,  133,  113,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  133,  133,  133,  133,  133,
  133,  133,  133,    0,    0,    0,  133,  133,  133,  133,
  133,  133,  133,  133,  133,    0,    0,  113,    0,    0,
    0,    0,    0,    0,  113,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  113,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  113,    0,    0,
  113,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  114,    0,    0,    0,    0,    0,  113,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  114,    0,    0,    0,
    0,    0,    0,  114,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  114,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  114,    0,    0,  114,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  114,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  113,  113,  113,  113,    0,    0,  113,    0,  113,
  113,  113,  113,    0,    0,    0,    0,    0,    0,    0,
    0,  113,  113,    0,  113,  113,  113,  113,  113,  113,
  113,  113,  113,  113,  113,  113,  113,  113,  113,  113,
  113,  113,  113,  113,  113,  113,    0,    0,    0,    0,
    0,  113,  113,  113,  113,  113,  113,  113,  113,  113,
  113,  113,  113,    0,    0,    0,    0,    0,  113,  113,
  113,  113,  113,  113,  113,  113,  113,  113,  113,    0,
    0,  113,  113,  113,  113,    0,    0,  113,  113,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  113,
  113,  113,  113,  113,  113,  113,  113,  113,    0,    0,
    0,  113,  113,  113,  113,  113,  113,  113,  113,  113,
  114,  114,  114,  114,    0,    0,  114,    0,  114,  114,
  114,  114,    0,    0,    0,    0,    0,    0,    0,    0,
  114,  114,    0,  114,  114,  114,  114,  114,  114,  114,
  114,  114,  114,  114,  114,  114,  114,  114,  114,  114,
  114,  114,  114,  114,  114,    0,    0,    0,    0,    0,
  114,  114,  114,  114,  114,  114,  114,  114,  114,  114,
  114,  114,    0,    0,    0,    0,    0,  114,  114,  114,
  114,  114,  114,  114,  114,  114,  114,  114,    0,    0,
  114,  114,  114,  114,    0,    0,  114,  114,  115,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  114,  114,
  114,  114,  114,  114,  114,  114,  114,    0,    0,    0,
  114,  114,  114,  114,  114,  114,  114,  114,  114,    0,
    0,  115,    0,    0,    0,    0,    0,    0,  115,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  115,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  115,    0,    0,  115,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  181,    0,    0,    0,
    0,    0,    0,  115,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  181,
    0,    0,    0,    0,    0,    0,  181,    0,    0,    0,
  181,  181,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  181,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  181,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  181,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  115,  115,  115,  115,    0,
    0,  115,    0,  115,  115,  115,  115,    0,    0,    0,
    0,    0,    0,    0,    0,  115,  115,    0,  115,  115,
  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
  115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
    0,    0,    0,    0,    0,  115,  115,  115,  115,  115,
  115,  115,  115,  115,  115,  115,  115,    0,    0,    0,
    0,    0,  115,  115,  115,  115,  115,  115,  115,  115,
  115,  115,  115,    0,    0,  115,  115,  115,  115,    0,
    0,  115,  115,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  115,  115,  115,  115,  115,  115,  115,
  115,  115,    0,    0,    0,  115,  115,  115,  115,  115,
  115,  115,  115,  115,  181,  181,  181,    0,    0,    0,
    0,  181,  181,  181,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  181,  181,    0,  181,  181,  181,  181,
  181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
  181,  181,  181,  181,  181,  181,  181,  181,    0,    0,
    0,    0,    0,  181,  181,  181,  181,  181,  181,  181,
  181,  181,  181,  181,  181,    0,    0,    0,    0,    0,
  181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
  181,    0,    0,  181,  181,  181,  181,    0,    0,  181,
  181,  156,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  181,  181,  181,  181,  181,  181,  181,  181,  181,
    0,    0,    0,  181,  181,  181,  181,  181,  181,  181,
  181,  181,    0,    0,  156,    0,    0,    0,    0,    0,
    0,  156,  156,    0,  156,  156,  156,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  156,    0,    0,  156,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  156,    0,    0,  156,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  161,    0,    0,    0,    0,    0,  156,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,    0,    0,    0,    0,    0,    0,
  161,    0,    0,  161,    0,  161,  161,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,    0,    0,  161,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  161,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  156,  156,
  156,  156,    0,    0,  156,    0,  156,  156,  156,  156,
    0,    0,    0,    0,    0,    0,    0,    0,  156,  156,
    0,  156,  156,  156,  156,  156,  156,  156,  156,  156,
  156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
  156,  156,  156,    0,    0,    0,    0,  156,  156,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
  156,  156,  156,  156,  156,  156,    0,    0,    0,    0,
    0,    0,    0,    0,  156,  156,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  156,  156,
  156,  156,  156,  156,  156,  156,  156,  161,  161,  161,
  161,    0,    0,  161,    0,  161,  161,  161,  161,    0,
    0,    0,    0,    0,    0,    0,    0,  161,  161,    0,
  161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
  161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
  161,  161,    0,    0,    0,    0,    0,  161,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  223,    0,  161,
  161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
  161,  161,  161,  161,  161,    0,    0,    0,    0,    0,
    0,    0,    0,  161,  161,    0,    0,    0,    0,    0,
  223,    0,    0,    0,  223,    0,    0,  223,    0,  223,
  223,  223,  223,    0,  223,    0,    0,  161,  161,  161,
  161,  161,  161,  161,  161,  161,  223,    0,    0,  223,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  223,  223,    0,  223,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  182,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  223,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  182,    0,    0,    0,    0,    0,    0,  182,  182,
    0,    0,  182,  182,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  259,    0,  182,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  182,  259,    0,  182,    0,  259,  259,  259,  259,
  259,    0,  259,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  259,  259,    0,  259,    0,    0,
    0,    0,    0,  182,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  223,  223,  223,  223,  259,    0,
  223,    0,    0,    0,    0,  223,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  223,  223,    0,    0,    0,    0,    0,    0,    0,
  259,    0,    0,    0,    0,    0,    0,    0,    0,  223,
    0,    0,  223,    0,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,    0,    0,    0,    0,
    0,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,    0,    0,  223,  223,  223,  223,    0,    0,
    0,    0,    0,    0,    0,    0,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,    0,    0,    0,    0,  182,  182,  182,  182,    0,
    0,  182,  223,  182,  182,  182,  182,    0,    0,    0,
    0,    0,    0,    0,    0,  182,  182,    0,  182,  182,
  182,  182,    0,    0,  182,  182,  182,  182,  182,  182,
  182,  182,  182,  182,  182,  182,  182,  182,  182,  182,
   43,    0,    0,    0,    0,  182,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  259,
    0,    0,  182,  182,  182,  182,  182,  182,  182,  182,
  182,  182,  182,   43,    0,    0,    0,    0,    0,    0,
   43,  182,  182,    0,    0,    0,  259,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  259,    0,   43,
  259,    0,    0,    0,    0,  182,  182,  182,  182,  182,
  182,  182,  182,  182,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,    0,    0,
    0,    0,    0,   43,    0,    0,   43,    0,    0,    0,
    0,    0,    0,    0,  259,  259,  259,  259,  259,  259,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
    0,    0,    0,    0,   45,   43,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
   45,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   96,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   96,    0,    0,   43,   43,   43,
   43,    0,    0,   43,    0,    0,    0,    0,   43,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   43,   43,    0,    0,   96,    0,
    0,    0,    0,    0,   98,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,    0,
   96,    0,    0,    0,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,    0,    0,   43,   43,   43,
   43,   45,   45,   45,   45,    0,    0,   45,    0,    0,
    0,    0,   45,   98,    0,   43,   43,   43,   43,   43,
   43,   43,   43,   43,    0,    0,    0,    0,   45,   45,
    0,    0,    0,    0,    0,   43,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   98,    0,    0,
    0,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,    0,    0,    0,    0,    0,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   98,
    0,   45,   45,   45,   45,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   92,    0,
    0,    0,    0,    0,    0,   96,    0,    0,    0,   45,
   96,   96,   96,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   96,   96,    0,   96,   96,   96,   96,   96,
   96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
   96,   96,   96,   96,   96,   96,   96,  204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   92,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   96,   96,
    0,   92,    0,    0,    0,    0,    0,   94,    0,    0,
    0,    0,    0,    0,   98,    0,    0,    0,    0,   98,
   98,   98,   96,   96,   96,   96,   96,   96,   96,   96,
   96,   98,   98,   92,   98,   98,   98,   98,   98,   98,
   98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
   98,   98,   98,   98,   98,   98,  203,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   94,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   98,   98,    0,
   94,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   98,   98,   98,   98,   98,   98,   98,   98,   98,
    0,    0,   94,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  108,    0,    0,    0,    0,    0,    0,   92,    0,
    0,    0,    0,   92,   92,   92,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   92,   92,    0,   92,   92,
   92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
   92,   92,   92,   92,   92,   92,   92,   92,   92,   92,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  108,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   92,   92,    0,  108,    0,    0,    0,    0,    0,
  110,    0,    0,    0,    0,    0,    0,   94,    0,    0,
    0,    0,   94,   94,   94,   92,   92,   92,   92,   92,
   92,   92,   92,   92,   94,   94,  108,   94,   94,   94,
   94,   94,   94,   94,   94,   94,   94,   94,   94,   94,
   94,   94,   94,   94,   94,   94,   94,   94,   94,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  110,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   94,   94,    0,  110,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   94,   94,   94,   94,   94,   94,
   94,   94,   94,    0,    0,  110,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,    0,    0,    0,    0,
    0,  108,    0,    0,    0,    0,  108,  108,  108,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  108,  108,
    0,  108,  108,  108,  108,  108,  108,  108,  108,  108,
  108,  108,  108,  108,  108,  108,  108,  108,  108,  108,
  108,  108,  108,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  108,  108,    0,  119,    0,    0,
    0,    0,    0,  112,    0,    0,    0,    0,    0,    0,
  110,    0,    0,    0,    0,  110,  110,  110,  108,  108,
  108,  108,  108,  108,  108,  108,  108,  110,  110,  119,
  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
  110,  110,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  112,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  110,  110,    0,  112,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  110,  110,  110,
  110,  110,  110,  110,  110,  110,    0,    0,  112,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,    0,    0,    0,  119,
  119,  119,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,  119,    0,  119,  119,  119,  119,  119,  119,
  119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
  119,  119,  119,  119,  119,  119,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,  119,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  112,    0,    0,    0,    0,  112,  112,
  112,  119,  119,  119,  119,  119,  119,  119,  119,  119,
  112,  112,    0,  112,  112,  112,  112,  112,  112,  112,
  112,  112,  112,  112,  112,  112,  112,  112,  112,  112,
  112,  112,  112,  112,  112,   83,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   83,    0,
    0,    0,    0,    0,    0,   83,  112,  112,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   83,    0,    0,    0,    0,    0,
  112,  112,  112,  112,  112,  112,  112,  112,  112,    0,
    0,    0,    0,    0,    0,    0,  161,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   83,    0,
    0,   83,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
   83,  161,  161,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  161,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  161,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   83,   83,   83,    0,    0,    0,   83,    0,
   83,   83,   83,   83,    0,    0,    0,    0,    0,    0,
    0,    0,   83,   83,    0,   83,   83,   83,   83,   83,
   83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
   83,   83,   83,   83,   83,   83,   83,    0,    0,    0,
    0,    0,   83,   83,   83,   83,   83,   83,   83,   83,
   83,   83,   83,   83,    0,    0,    0,    0,    0,   83,
   83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
    0,    0,   83,   83,   83,   83,    0,    0,   83,   83,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   83,   83,   83,   83,   83,   83,   83,   83,   83,    0,
  161,  161,   83,   83,   83,   83,   83,   83,   83,   83,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  161,  161,  161,  161,  161,  161,
  161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
   95,    0,    0,    0,    0,    0,    0,   92,    0,    0,
    0,    0,   94,  161,  161,  161,  161,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  161,  161,  161,  161,  161,  161,  161,  161,  161,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   32,    0,
    0,    0,    0,   93,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   33,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    6,    0,    0,    0,    0,    0,    0,    6,    0,    0,
    0,    0,    6,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    6,    0,
    0,    0,    0,    6,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    6,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  303,  304,   51,    8,    9,    0,
   52,    0,    0,    0,    0,   53,   10,   11,   12,   13,
   14,   15,   16,   17,    0,    0,   18,   95,    0,   19,
   20,  305,  306,    0,  112,    0,    0,    0,    0,   94,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   56,   57,   58,   59,   60,   61,
   62,   63,   64,   65,   66,   67,    0,    0,    0,    0,
    0,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   77,   78,   23,    0,   79,   80,   81,   82,   24,   25,
   93,    0,   26,    0,   27,    0,    0,    0,    0,    0,
    0,    0,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   28,    0,   29,    6,    6,    6,    6,    6,    0,
    6,    0,   30,   31,    0,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    0,    0,    6,    0,    0,    6,
    6,    6,    6,    0,    0,    0,  113,    0,    0,    0,
    0,    0,    0,  112,  323,    0,    0,    0,   94,    0,
    0,    0,    0,    0,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    0,    0,    0,    0,
    0,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    0,    6,    6,    6,    6,    6,    6,
    0,    0,    6,    0,    6,    0,    0,    0,    0,   93,
    0,    0,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    0,    6,    0,    0,    0,    0,    0,    0,
    0,    0,    6,    6,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   49,   50,   51,    8,    0,    0,   52,    0,  129,
  130,  131,   53,    0,    0,    0,    0,    0,    0,    0,
    0,  132,  133,    0,  134,  135,  136,  137,  138,  139,
  140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
  150,  151,  152,  153,  154,  155,    0,    0,    0,    0,
    0,   56,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,    0,    0,    0,    0,    0,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,  113,
    0,   79,   80,   81,   82,    0,   92,  156,  157,    0,
    0,   94,  282,    0,    0,    0,    0,    0,    0,   83,
   84,   85,   86,   87,   88,   89,   90,   91,    0,    0,
    0,  158,  159,  160,  161,  162,  163,  164,  165,   30,
   49,   50,   51,    8,    0,    0,   52,    0,    0,    0,
    0,   53,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   93,    0,    0,    0,    0,   54,   55,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,    0,    0,    0,    0,    0,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   95,    0,
   79,   80,   81,   82,    0,   92,    0,    0,    0,    0,
   94,    0,    0,    0,    0,    0,    0,    0,   83,   84,
   85,   86,   87,   88,   89,   90,   91,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   30,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   93,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  113,    0,    0,    0,    0,    0,    0,  112,
    0,    0,    0,    0,   94,    0,    0,    0,    0,    0,
    0,    0,    0,   49,   50,   51,    8,    0,    0,   52,
    0,    0,    0,    0,   53,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   54,   55,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   93,    0,    0,    0,    0,
    0,    0,    0,   56,   57,   58,   59,   60,   61,   62,
   63,   64,   65,   66,   67,    0,    0,    0,    0,    0,
   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
   78,    0,    0,   79,   80,   81,   82,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   83,   84,   85,   86,   87,   88,   89,   90,   91,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   30,   49,   50,   51,    8,    0,    0,   52,    0,
    0,    0,    0,   53,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  113,    0,   54,
   55,    0,    0,    0,   92,    0,    0,    0,    0,   94,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   56,   57,   58,   59,   60,   61,   62,   63,
   64,   65,   66,   67,    0,    0,    0,    0,    0,   68,
   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
    0,    0,   79,   80,   81,   82,   49,   50,   51,    8,
   93,    0,   52,    0,    0,    0,    0,   53,    0,    0,
   83,   84,   85,   86,   87,   88,   89,   90,   91,    0,
    0,  113,    0,   54,   55,    0,    0,    0,  289,    0,
   30,    0,    0,   94,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   56,   57,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,    0,    0,
    0,    0,    0,   68,   69,   70,   71,   72,   73,   74,
   75,   76,   77,   78,    0,    0,   79,   80,   81,   82,
    0,    0,    0,    0,   93,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   83,   84,   85,   86,   87,   88,
   89,   90,   91,    0,    0,   95,    0,    0,    0,    0,
    0,    0,  283,    0,   30,    0,    0,   94,  282,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   49,   50,   51,    8,    0,    0,   52,   93,    0,
    0,    0,   53,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   54,   55,
   95,    0,    0,    0,    0,    0,    0,  112,    0,  449,
    0,    0,   94,    0,    0,    0,    0,    0,    0,    0,
    0,   56,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,    0,    0,    0,    0,    0,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,    0,
    0,   79,   80,   81,   82,   49,   50,   51,    8,    0,
    0,   52,    0,   93,    0,    0,   53,    0,    0,   83,
   84,   85,   86,   87,   88,   89,   90,   91,    0,    0,
    0,    0,   54,   55,   95,    0,    0,    0,    0,   30,
    0,  112,    0,    0,    0,    0,   94,    0,    0,    0,
    0,    0,    0,    0,    0,   56,   57,   58,   59,   60,
   61,   62,   63,   64,   65,   66,   67,    0,    0,    0,
    0,    0,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,    0,    0,   79,   80,   81,   82,  279,
   50,   51,    0,    0,    0,  280,    0,   93,    0,    0,
  281,    0,    0,   83,   84,   85,   86,   87,   88,   89,
   90,   91,    0,    0,    0,    0,   54,   55,   95,    0,
    0,    0,    0,   30,    0,   92,    0,    0,    0,    0,
   94,    0,    0,    0,    0,    0,    0,    0,    0,   56,
   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
   67,    0,    0,    0,    0,    0,   68,   69,   70,   71,
   72,   73,   74,   75,   76,   77,   78,    0,    0,   79,
   80,   81,   82,    0,   49,   50,   51,    0,    0,    0,
   52,   93,    0,    0,    0,   53,    0,   83,   84,   85,
   86,   87,   88,   89,   90,   91,    0,    0,    0,    0,
    0,   54,   55,   95,    0,    0,    0,    0,    0,    0,
  289,    0,    0,    0,    0,   94,    0,    0,    0,    0,
    0,    0,    0,    0,   56,   57,   58,   59,   60,   61,
   62,   63,   64,   65,   66,   67,    0,    0,    0,    0,
    0,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   77,   78,    0,    0,   79,   80,   81,   82,   49,   50,
   51,    0,    0,    0,   52,    0,   93,    0,    0,   53,
    0,    0,   83,   84,   85,   86,   87,   88,   89,   90,
   91,    0,    0,    0,    0,   54,   55,   95,    0,    0,
    0,    0,    0,    0,  112,    0,    0,    0,    0,   94,
    0,    0,    0,    0,    0,    0,    0,    0,   56,   57,
   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
    0,    0,    0,    0,    0,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,   78,    0,    0,   79,   80,
   81,   82,   49,   50,   51,    0,    0,    0,   52,    0,
   93,    0,    0,   53,    0,    0,   83,   84,   85,   86,
   87,   88,   89,   90,   91,    0,    0,    0,    0,   54,
   55,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   56,   57,   58,   59,   60,   61,   62,   63,
   64,   65,   66,   67,    0,    0,    0,    0,    0,   68,
   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
    0,    0,   79,   80,   81,   82,    0,   49,   50,   51,
    0,    0,    0,   52,    0,    0,    0,    0,   53,    0,
   83,   84,   85,   86,   87,   88,   89,   90,   91,    0,
    0,    0,    0,    0,   54,   55,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   56,   57,   58,
   59,   60,   61,   62,   63,   64,   65,   66,   67,    0,
    0,    0,    0,    0,   68,   69,   70,   71,   72,   73,
   74,   75,   76,   77,   78,    0,    0,   79,   80,   81,
   82,   49,   50,   51,    0,    0,    0,   52,    0,    0,
    0,    0,   53,    0,    0,   83,   84,   85,   86,   87,
   88,   89,   90,   91,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   56,   57,   58,   59,   60,   61,   62,   63,   64,
   65,   66,   67,    0,    0,    0,    0,    0,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,    0,
    0,   79,   80,   81,   82,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   83,
   84,   85,   86,   87,   88,   89,   90,   91,
};
static const YYINT yycheck[] = {                         25,
   44,  260,   41,   29,   37,   31,  128,   59,  107,   42,
   43,   37,   45,   43,   47,   45,    0,  260,  102,   59,
  260,   43,   43,   45,   45,  268,    0,   60,   37,   62,
  109,    0,   61,   42,   43,   58,   45,   37,   47,  258,
   62,   96,   42,   43,  123,   45,    0,   47,  170,    4,
  258,   60,   36,   62,   43,   43,   45,   45,   42,   25,
   60,   94,   62,   40,   58,   31,   92,   61,   94,   95,
   25,  348,   41,   92,   62,   44,   31,  336,   41,  257,
  258,   44,   37,  109,   27,   94,    0,  113,   61,   43,
   59,   45,   41,  262,   94,   44,   40,  123,  284,  285,
   43,   43,   44,   45,  336,   59,  132,  133,  134,  135,
  136,  137,  138,  139,  140,  141,  142,  143,  144,   93,
   40,  147,  148,  149,   93,  144,   92,   40,  113,   43,
    0,   45,  158,  159,   25,  375,   40,  163,  164,   93,
   31,   40,  226,  109,  170,   59,   43,   44,   45,   60,
   93,  125,  349,  350,  109,   37,  125,  123,  351,  352,
   42,   43,   44,   45,   96,   47,  121,   40,  123,  355,
  356,  125,   40,  128,  140,  141,  142,  143,   60,   93,
   62,  280,  281,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  284,   92,  257,    0,  170,  160,  161,  162,  263,  235,
  236,  125,   94,  268,  258,  170,  235,  236,  109,   40,
   91,  124,  125,   93,  250,   40,   40,  253,  254,  172,
  256,  257,  123,    0,   40,   61,  179,  180,  181,  182,
  183,  184,  185,  186,  187,  188,  189,  302,  291,  140,
  141,  142,  143,  260,  258,  125,  262,  283,  224,  225,
  260,   60,   59,  289,  283,   41,   33,   41,  253,  254,
  289,  256,  257,   40,   94,  303,  306,  376,   45,  170,
  319,  320,  321,  322,  323,  306,  264,   46,  410,  279,
  257,  284,  285,  283,  125,  264,   93,   43,   44,   45,
  326,  327,   93,  258,  259,  331,  332,  333,  263,   43,
   44,   45,   93,  332,  333,  262,  349,  283,  351,  352,
  353,  354,  291,  257,   91,  257,  262,    0,  125,   96,
   41,  263,   37,  224,  225,    0,  268,   42,   43,   41,
   45,   91,   47,    0,  353,  354,   43,   44,   45,  349,
  350,  351,  352,  353,  354,   60,  123,   62,   44,   41,
  326,  327,  355,  356,   41,  331,   43,   41,   45,   43,
    0,   45,    0,   41,   41,  375,  304,   41,  404,  405,
  406,  350,  408,   44,   44,   37,   59,  377,  378,   94,
   42,   43,  283,   45,   59,   47,  422,  423,  269,  270,
  271,  272,  273,  274,   41,  276,   41,  262,   60,  349,
   62,   41,   44,   41,   44,  257,   44,  365,  444,   41,
   93,  411,   41,  449,  414,  305,   41,   37,   93,   59,
  260,   59,   42,   41,   91,  326,  327,   47,  404,  405,
  331,  346,   94,   43,   44,   45,  389,   43,   44,   45,
  393,  394,  125,   41,   41,  410,  422,  423,   41,  262,
  125,    0,   41,   93,  260,   93,  123,  349,  350,  351,
  352,  353,  354,   37,   46,   43,   44,   45,   42,   43,
  346,   45,   44,   47,   94,  319,  320,  321,  322,  323,
  257,  258,  259,  260,  261,  125,  263,  125,  346,  346,
  170,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  260,   31,  279,  404,  405,  282,  283,  284,  285,  269,
  270,  271,  272,  273,  274,   36,  276,    0,    0,  416,
   94,  422,  423,   -1,   46,  198,   -1,   -1,   -1,   -1,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,  335,   -1,
  337,  338,  339,  340,  341,  342,   -1,   -1,  345,   -1,
  347,   -1,   -1,   -1,   -1,   -1,   59,   59,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,    0,  366,
  257,  258,   -1,  260,  261,   -1,   -1,   -1,  375,  376,
    0,   -1,  269,  270,  271,  272,  273,  274,  275,  276,
   93,   93,  279,    0,   -1,  282,  283,  284,  285,   -1,
   -1,   33,   -1,   -1,  264,   37,  264,   -1,   40,   41,
   42,   43,   44,   45,  349,   47,  351,  352,  353,  354,
   -1,   41,  125,  125,   44,   -1,    0,   59,   60,   -1,
   62,  291,   -1,  291,   -1,   -1,   -1,   -1,   -1,   59,
    0,   -1,  302,   -1,  302,  305,   -1,  305,  335,   -1,
   -1,   -1,   59,   -1,  341,  342,   -1,   -1,  345,   -1,
  347,   93,   -1,   -1,   96,   -1,   -1,  349,  350,  351,
  352,  353,  354,   93,   -1,   -1,   -1,  364,   -1,  366,
   -1,   -1,  284,  285,   -1,   59,   93,    0,  375,  376,
  350,  349,  350,  125,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,  125,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,  125,   93,
   33,   -1,   -1,   -1,   37,   -1,   -1,   40,   41,   42,
   43,   44,   45,   93,   47,  337,  338,  339,  340,   -1,
   -1,   -1,  284,  285,   -1,   -1,   59,   60,   -1,   62,
   -1,  125,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  125,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,    0,
   93,   -1,   -1,   96,   37,   -1,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,  337,  338,  339,  340,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,
   -1,   -1,  125,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  263,  264,  265,  266,  267,  268,   -1,   59,   -1,
   -1,   94,   -1,   -1,  264,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  291,   93,  305,  306,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,  125,  337,  338,  339,  340,   -1,
   46,  343,  344,   -1,  346,   -1,   -1,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  257,  258,  259,  260,   -1,   -1,
  263,  264,  265,  266,  267,  268,   -1,   91,   -1,   -1,
   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,
  343,  344,    0,  346,  287,   -1,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,
  373,  374,  375,   -1,   -1,   33,   -1,   92,   -1,   37,
   -1,   -1,   40,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   60,   -1,   62,   -1,  349,  350,  351,  352,
  353,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  140,  141,  142,  143,   -1,
   -1,   -1,   -1,   -1,   -1,   93,  260,   -1,   96,   -1,
   -1,   -1,   -1,   -1,  268,  269,  270,  271,  272,  273,
  274,   -1,  276,   -1,   -1,  170,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   33,   -1,   -1,   -1,   37,   -1,
   -1,   40,   41,   42,   43,   44,   45,   -1,   47,  224,
  225,  337,  338,  339,  340,   -1,   -1,   -1,   -1,   -1,
   59,   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   37,   -1,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   60,   37,   62,   -1,   -1,  283,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  125,   60,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,  257,
  258,  259,  260,   -1,   -1,  263,  264,  265,  266,  267,
  268,  326,  327,   -1,   -1,   -1,  331,   -1,   -1,  277,
  278,   94,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,   -1,   -1,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,   -1,  337,
  338,  339,  340,   -1,   -1,  343,  344,   -1,  346,  404,
  405,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,   -1,  422,  423,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  257,  258,
  259,  260,   -1,   -1,  263,  264,  265,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,   -1,   -1,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,  337,  338,
  339,  340,   -1,   -1,  343,  344,    0,  346,   -1,   -1,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,
  369,  370,  371,  372,  373,  374,  375,   -1,   -1,   33,
   -1,   -1,   -1,   37,   -1,   -1,   40,   41,   42,   43,
   44,   45,   -1,   47,  351,  352,  353,  354,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   59,   60,   -1,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  349,  350,  351,  352,
  353,  354,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   96,   -1,   41,   -1,   60,   44,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   33,   -1,
   -1,   -1,   37,   -1,   -1,   40,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   -1,   62,  125,   -1,
   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   37,   -1,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   60,   -1,   62,   93,   -1,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,  257,  258,  259,  260,   -1,   -1,  263,
  264,  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,   -1,
   -1,  305,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,   -1,   -1,  264,   -1,   -1,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,   -1,  337,  338,  339,  340,   -1,  302,  343,
  344,  305,  346,   -1,  291,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  257,  258,  259,  260,   -1,   -1,  263,  264,
  265,  266,  267,  268,   -1,  349,  350,  351,  352,  353,
  354,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,   -1,   -1,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,   -1,  290,   -1,   -1,   -1,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,
    0,  346,   -1,   -1,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,   -1,  367,  368,  369,  370,  371,  372,  373,  374,
  375,   -1,   -1,   33,  349,  350,  351,  352,  353,  354,
   40,   41,   -1,   43,   44,   45,  349,  350,  351,  352,
  353,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   -1,   43,   44,   45,  337,  338,  339,  340,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   -1,   62,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  263,  264,  265,  266,  267,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,   -1,
   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,  337,  338,  339,
  340,   -1,  302,  343,  344,  305,  346,   -1,   -1,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  257,  258,  259,  260,
   -1,   -1,  263,  264,  265,  266,  267,  268,   -1,  349,
  350,  351,  352,  353,  354,   -1,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,   -1,   -1,  305,  306,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,   -1,   -1,
   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,   -1,  337,  338,  339,  340,
   -1,   -1,  343,  344,    0,  346,   -1,   -1,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,
  371,  372,  373,  374,  375,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   -1,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   -1,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,  264,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,   -1,   -1,  305,
  306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
   -1,  337,  338,  339,  340,   -1,  302,  343,  344,  305,
  346,   -1,   -1,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   -1,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  257,  258,  259,  260,   -1,   -1,  263,  264,  265,  266,
  267,  268,   -1,  349,  350,  351,  352,  353,  354,   -1,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,   -1,   -1,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,  339,  340,   -1,   -1,  343,  344,    0,  346,
   -1,   -1,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,
  367,  368,  369,  370,  371,  372,  373,  374,  375,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   -1,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   60,   -1,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  263,  264,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,   -1,   -1,  305,  306,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,
  302,  343,  344,  305,  346,   -1,   -1,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  257,  258,  259,  260,   -1,   -1,
  263,  264,  265,  266,  267,  268,   -1,  349,  350,  351,
  352,  353,  354,   -1,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
   -1,   -1,  305,  306,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,    0,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,
  343,  344,    0,  346,   -1,   -1,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,
  373,  374,  375,   -1,   -1,   33,   -1,   -1,   59,   -1,
   -1,   -1,   40,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   -1,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,
   59,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,  125,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,
   -1,   -1,  263,   -1,   -1,   -1,  125,  268,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,  263,   -1,  265,  266,  267,
  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,
  278,  302,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,   -1,   -1,   -1,   -1,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,  257,  337,
  338,  339,  340,   -1,  263,  343,  344,   -1,   -1,  268,
   -1,   -1,   -1,   -1,   -1,  264,   -1,  355,  356,  357,
  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  257,  258,
  259,  260,  291,  302,  263,  264,  265,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,   -1,   -1,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  349,  350,   -1,   -1,   -1,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,  337,  338,
  339,  340,   -1,   -1,  343,  344,    0,  346,   -1,   -1,
  349,  350,  351,  352,   -1,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,
  369,  370,  371,  372,  373,  374,  375,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   41,   -1,   43,   44,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,  263,
  264,  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,   -1,
   -1,  305,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,
  344,   -1,  346,   -1,   -1,  349,  350,  351,  352,   -1,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  257,  258,  259,  260,   -1,   -1,  263,  104,
  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,   -1,  143,   -1,
   -1,  306,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,   -1,  367,  368,  369,  370,  371,  372,  373,  374,
  375,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   93,  279,   -1,   96,   -1,  283,   -1,
   -1,  286,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,  125,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  411,   -1,   -1,  414,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  263,  264,  265,  266,  267,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,   -1,   -1,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,   -1,
   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,  337,  338,  339,
  340,   -1,   -1,  343,  344,   -1,  346,   -1,   -1,  349,
  350,   -1,   -1,  264,   -1,  355,  356,  357,  358,  359,
  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  257,  258,  259,  260,
  291,   -1,  263,  264,  265,  266,  267,  268,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,   -1,   -1,  305,  306,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,   -1,  350,
   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,   -1,  337,  338,  339,  340,
   -1,   -1,  343,  344,    0,  346,   -1,   -1,   -1,  350,
   -1,   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,
  371,  372,  373,  374,  375,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   41,   -1,   43,   44,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   93,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   62,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,  125,   96,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,
  306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   59,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,  264,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   -1,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  257,  258,  259,  260,  291,   -1,  263,  123,  265,  266,
  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,   -1,  350,   -1,   -1,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,  339,  340,   -1,   -1,  343,  344,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,
  367,  368,  369,  370,  371,  372,  373,  374,  375,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,   -1,  260,  261,   -1,   59,   -1,   -1,
   -1,   -1,   -1,  269,  270,  271,  272,  273,  274,  275,
  276,   -1,   -1,  279,   -1,   -1,  282,  283,  284,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,  335,
   -1,   -1,   -1,   -1,   -1,  341,  342,   -1,   -1,  345,
   -1,  347,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,  364,   -1,
  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  375,
  376,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  263,   -1,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
   -1,   -1,   -1,   -1,  306,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,
   -1,  343,  344,   -1,   -1,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  257,  258,  259,  260,   -1,  123,
  263,   -1,  265,  266,  267,  268,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,   -1,
   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,
  343,  344,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,
  373,  374,  375,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,   -1,  260,  261,   -1,   -1,
   -1,   59,   -1,   -1,   -1,  269,  270,  271,  272,  273,
  274,  275,  276,   -1,   -1,  279,   -1,   -1,  282,  283,
  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,  342,   -1,
   -1,  345,   -1,  347,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
  364,   40,  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  375,  376,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,  263,   -1,  265,  266,  267,
  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,   -1,   -1,   -1,   -1,   -1,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,   -1,  337,
  338,  339,  340,   -1,   -1,  343,  344,   -1,   -1,   -1,
   -1,   91,   -1,   -1,   -1,   -1,   -1,  355,  356,  357,
  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  257,  258,
  259,  260,   -1,  123,  263,   -1,  265,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,   -1,   -1,   -1,   -1,   -1,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,  337,  338,
  339,  340,   -1,   -1,  343,  344,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,
  369,  370,  371,  372,  373,  374,  375,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,   -1,
  260,  261,   -1,   -1,   -1,   59,   -1,   -1,   -1,  269,
  270,  271,  272,  273,  274,  275,  276,   -1,   -1,  279,
   -1,   -1,  282,  283,  284,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,
   -1,  341,  342,   -1,   -1,  345,   -1,  347,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,  364,   40,  366,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  375,  376,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,  263,
   -1,  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,   -1,   -1,
   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,
  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  257,  258,  259,  260,   -1,   -1,  263,   -1,
  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,
   -1,   -1,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,   -1,  367,  368,  369,  370,  371,  372,  373,  374,
  375,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,   -1,
   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,  337,  338,  339,
  340,   -1,   -1,  343,  344,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,  356,  357,  358,  359,
  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  257,  258,  259,  260,
   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,   -1,   -1,
   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,   -1,  337,  338,  339,  340,
   -1,   -1,  343,  344,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,
  371,  372,  373,  374,  375,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   -1,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,  266,
  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,   -1,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,  339,  340,   -1,   -1,  343,  344,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,
  367,  368,  369,  370,  371,  372,  373,  374,  375,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  263,   -1,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
   -1,   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,
   -1,  343,  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  257,  258,  259,  260,   -1,   -1,
  263,   -1,  265,  266,  267,  268,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,   -1,
   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,
  343,  344,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,
  373,  374,  375,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,  263,   -1,  265,  266,  267,
  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,   -1,   -1,   -1,   -1,   -1,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,   -1,  337,
  338,  339,  340,   -1,   -1,  343,  344,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,  357,
  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  257,  258,
  259,  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,   -1,   -1,   -1,   -1,   -1,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,  337,  338,
  339,  340,   -1,   -1,  343,  344,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,
  369,  370,  371,  372,  373,  374,  375,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,  263,
   -1,  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,   -1,   -1,
   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,
  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,  373,
  374,  375,  257,  258,  259,  260,   -1,   -1,  263,   -1,
  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,
   -1,   -1,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,   -1,  367,  368,  369,  370,  371,  372,  373,  374,
  375,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,   -1,
   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,  337,  338,  339,
  340,   -1,   -1,  343,  344,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,  356,  357,  358,  359,
  360,  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  257,  258,  259,  260,
   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,   -1,   -1,
   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,   -1,  337,  338,  339,  340,
   -1,   -1,  343,  344,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,
  371,  372,  373,  374,  375,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   -1,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,  266,
  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,   -1,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   -1,   -1,
  337,  338,  339,  340,   -1,   -1,  343,  344,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,
  367,  368,  369,  370,  371,  372,  373,  374,  375,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  263,   -1,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
   -1,   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,
   -1,  343,  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  258,  259,  260,   -1,   -1,   -1,
   -1,  265,  266,  267,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,   -1,   -1,
   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,
  344,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,  373,
  374,  375,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   -1,   43,   44,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   46,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,   -1,   -1,   -1,   -1,  306,  307,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  343,  344,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  257,  258,  259,
  260,   -1,   -1,  263,   -1,  265,  266,  267,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,   -1,   -1,   -1,   -1,   -1,  307,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,  344,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   37,   -1,   -1,   40,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,  367,  368,  369,
  370,  371,  372,  373,  374,  375,   59,   -1,   -1,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   37,   -1,   96,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   -1,   62,   -1,   -1,
   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,   93,   -1,
  263,   -1,   -1,   -1,   -1,  268,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,
   -1,   -1,  305,   -1,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,   -1,   -1,   -1,   -1,  257,  258,  259,  260,   -1,
   -1,  263,  375,  265,  266,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,   -1,   -1,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
    0,   -1,   -1,   -1,   -1,  307,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  264,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   40,  343,  344,   -1,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,   -1,   59,
  305,   -1,   -1,   -1,   -1,  367,  368,  369,  370,  371,
  372,  373,  374,  375,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   96,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  349,  350,  351,  352,  353,  354,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   40,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  263,   -1,   -1,   -1,   -1,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  284,  285,   -1,   -1,   93,   -1,
   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,   -1,
  125,   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,  337,  338,  339,
  340,  257,  258,  259,  260,   -1,   -1,  263,   -1,   -1,
   -1,   -1,  268,   59,   -1,  355,  356,  357,  358,  359,
  360,  361,  362,  363,   -1,   -1,   -1,   -1,  284,  285,
   -1,   -1,   -1,   -1,   -1,  375,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   -1,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,  125,
   -1,  337,  338,  339,  340,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,    0,   -1,
   -1,   -1,   -1,   -1,   -1,  260,   -1,   -1,   -1,  375,
  265,  266,  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  343,  344,
   -1,   93,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,  265,
  266,  267,  367,  368,  369,  370,  371,  372,  373,  374,
  375,  277,  278,  125,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  343,  344,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,  368,  369,  370,  371,  372,  373,  374,  375,
   -1,   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,  260,   -1,
   -1,   -1,   -1,  265,  266,  267,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  343,  344,   -1,   93,   -1,   -1,   -1,   -1,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,  260,   -1,   -1,
   -1,   -1,  265,  266,  267,  367,  368,  369,  370,  371,
  372,  373,  374,  375,  277,  278,  125,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  343,  344,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,  368,  369,  370,  371,  372,
  373,  374,  375,   -1,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
   -1,  260,   -1,   -1,   -1,   -1,  265,  266,  267,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  343,  344,   -1,   93,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
  260,   -1,   -1,   -1,   -1,  265,  266,  267,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  277,  278,  125,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  343,  344,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,  369,
  370,  371,  372,  373,  374,  375,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,  265,
  266,  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  343,  344,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  260,   -1,   -1,   -1,   -1,  265,  266,
  267,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,
   -1,   -1,   -1,   -1,   -1,   40,  343,  344,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
  367,  368,  369,  370,  371,  372,  373,  374,  375,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   43,
  125,   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,   -1,   -1,   -1,  263,   -1,
  265,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,
   -1,   -1,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,   -1,   -1,  343,  344,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
  284,  285,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   -1,   -1,   45,  337,  338,  339,  340,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   -1,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   -1,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,   -1,
  263,   -1,   -1,   -1,   -1,  268,  269,  270,  271,  272,
  273,  274,  275,  276,   -1,   -1,  279,   33,   -1,  282,
  283,  284,  285,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,  335,   -1,  337,  338,  339,  340,  341,  342,
   96,   -1,  345,   -1,  347,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,   -1,  366,  257,  258,  259,  260,  261,   -1,
  263,   -1,  375,  376,   -1,  268,  269,  270,  271,  272,
  273,  274,  275,  276,   -1,   -1,  279,   -1,   -1,  282,
  283,  284,  285,   -1,   -1,   -1,   33,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   -1,   -1,   -1,   45,   -1,
   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,  335,   -1,  337,  338,  339,  340,  341,  342,
   -1,   -1,  345,   -1,  347,   -1,   -1,   -1,   -1,   96,
   -1,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  375,  376,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,   -1,  265,
  266,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   33,
   -1,  337,  338,  339,  340,   -1,   40,  343,  344,   -1,
   -1,   45,   46,   -1,   -1,   -1,   -1,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   -1,  367,  368,  369,  370,  371,  372,  373,  374,  375,
  257,  258,  259,  260,   -1,   -1,  263,   -1,   -1,   -1,
   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   96,   -1,   -1,   -1,   -1,  284,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  333,  334,   33,   -1,
  337,  338,  339,  340,   -1,   40,   -1,   -1,   -1,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   96,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,  263,
   -1,   -1,   -1,   -1,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  284,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   96,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,
  324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
  334,   -1,   -1,  337,  338,  339,  340,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,  356,  357,  358,  359,  360,  361,  362,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  375,  257,  258,  259,  260,   -1,   -1,  263,   -1,
   -1,   -1,   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   33,   -1,  284,
  285,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,  257,  258,  259,  260,
   96,   -1,  263,   -1,   -1,   -1,   -1,  268,   -1,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,   33,   -1,  284,  285,   -1,   -1,   -1,   40,   -1,
  375,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,   -1,   -1,
   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,  330,
  331,  332,  333,  334,   -1,   -1,  337,  338,  339,  340,
   -1,   -1,   -1,   -1,   96,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  355,  356,  357,  358,  359,  360,
  361,  362,  363,   -1,   -1,   33,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,  375,   -1,   -1,   45,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,   -1,   -1,  263,   96,   -1,
   -1,   -1,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,  285,
   33,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   42,
   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
   -1,  337,  338,  339,  340,  257,  258,  259,  260,   -1,
   -1,  263,   -1,   96,   -1,   -1,  268,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,   -1,   -1,
   -1,   -1,  284,  285,   33,   -1,   -1,   -1,   -1,  375,
   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,
   -1,   -1,  324,  325,  326,  327,  328,  329,  330,  331,
  332,  333,  334,   -1,   -1,  337,  338,  339,  340,  257,
  258,  259,   -1,   -1,   -1,  263,   -1,   96,   -1,   -1,
  268,   -1,   -1,  355,  356,  357,  358,  359,  360,  361,
  362,  363,   -1,   -1,   -1,   -1,  284,  285,   33,   -1,
   -1,   -1,   -1,  375,   -1,   40,   -1,   -1,   -1,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,
  328,  329,  330,  331,  332,  333,  334,   -1,   -1,  337,
  338,  339,  340,   -1,  257,  258,  259,   -1,   -1,   -1,
  263,   96,   -1,   -1,   -1,  268,   -1,  355,  356,  357,
  358,  359,  360,  361,  362,  363,   -1,   -1,   -1,   -1,
   -1,  284,  285,   33,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,   -1,   -1,   -1,   -1,
   -1,  324,  325,  326,  327,  328,  329,  330,  331,  332,
  333,  334,   -1,   -1,  337,  338,  339,  340,  257,  258,
  259,   -1,   -1,   -1,  263,   -1,   96,   -1,   -1,  268,
   -1,   -1,  355,  356,  357,  358,  359,  360,  361,  362,
  363,   -1,   -1,   -1,   -1,  284,  285,   33,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
   -1,   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,   -1,   -1,  337,  338,
  339,  340,  257,  258,  259,   -1,   -1,   -1,  263,   -1,
   96,   -1,   -1,  268,   -1,   -1,  355,  356,  357,  358,
  359,  360,  361,  362,  363,   -1,   -1,   -1,   -1,  284,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
   -1,   -1,  337,  338,  339,  340,   -1,  257,  258,  259,
   -1,   -1,   -1,  263,   -1,   -1,   -1,   -1,  268,   -1,
  355,  356,  357,  358,  359,  360,  361,  362,  363,   -1,
   -1,   -1,   -1,   -1,  284,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,   -1,
   -1,   -1,   -1,   -1,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,   -1,   -1,  337,  338,  339,
  340,  257,  258,  259,   -1,   -1,   -1,  263,   -1,   -1,
   -1,   -1,  268,   -1,   -1,  355,  356,  357,  358,  359,
  360,  361,  362,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,   -1,   -1,   -1,   -1,   -1,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  333,  334,   -1,
   -1,  337,  338,  339,  340,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
  356,  357,  358,  359,  360,  361,  362,  363,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 378
#define YYUNDFTOKEN 428
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,
0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,"'`'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"LABEL","VARIABLE","NUMBER",
"TEXT","COMMAND_LINE","DELIMITED","ORDINAL","TH","LEFT_ARROW_HEAD",
"RIGHT_ARROW_HEAD","DOUBLE_ARROW_HEAD","LAST","BOX","CIRCLE","ELLIPSE","ARC",
"LINE","ARROW","MOVE","SPLINE","HEIGHT","RADIUS","FIGNAME","WIDTH","DIAMETER",
"UP","DOWN","RIGHT","LEFT","FROM","TO","AT","WITH","BY","THEN","SOLID","DOTTED",
"DASHED","CHOP","SAME","INVISIBLE","LJUST","RJUST","ABOVE","BELOW","OF","THE",
"WAY","BETWEEN","AND","HERE","DOT_N","DOT_E","DOT_W","DOT_S","DOT_NE","DOT_SE",
"DOT_NW","DOT_SW","DOT_C","DOT_START","DOT_END","DOT_X","DOT_Y","DOT_HT",
"DOT_WID","DOT_RAD","SIN","COS","ATAN2","LOG","EXP","SQRT","K_MAX","K_MIN",
"INT","RAND","SRAND","COPY","THRU","TOP","BOTTOM","UPPER","LOWER","SH","PRINT",
"CW","CCW","FOR","DO","IF","ELSE","ANDAND","OROR","NOTEQUAL","EQUALEQUAL",
"LESSEQUAL","GREATEREQUAL","LEFT_CORNER","RIGHT_CORNER","NORTH","SOUTH","EAST",
"WEST","CENTER","END","START","RESET","UNTIL","PLOT","THICKNESS","FILL",
"COLORED","OUTLINED","SHADED","XSLANTED","YSLANTED","ALIGNED","SPRINTF",
"COMMAND","DEFINE","UNDEF",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : top",
"top : optional_separator",
"top : element_list",
"element_list : optional_separator middle_element_list optional_separator",
"middle_element_list : element",
"middle_element_list : middle_element_list separator element",
"optional_separator :",
"optional_separator : separator",
"separator : ';'",
"separator : separator ';'",
"placeless_element : FIGNAME '=' macro_name",
"placeless_element : VARIABLE '=' any_expr",
"placeless_element : VARIABLE ':' '=' any_expr",
"placeless_element : UP",
"placeless_element : DOWN",
"placeless_element : LEFT",
"placeless_element : RIGHT",
"placeless_element : COMMAND_LINE",
"placeless_element : COMMAND print_args",
"placeless_element : PRINT print_args",
"$$1 :",
"placeless_element : SH $$1 DELIMITED",
"placeless_element : COPY TEXT",
"$$2 :",
"$$3 :",
"placeless_element : COPY TEXT THRU $$2 DELIMITED $$3 until",
"$$4 :",
"$$5 :",
"placeless_element : COPY THRU $$4 DELIMITED $$5 until",
"$$6 :",
"placeless_element : FOR VARIABLE '=' expr TO expr optional_by DO $$6 DELIMITED",
"placeless_element : simple_if",
"$$7 :",
"placeless_element : simple_if ELSE $$7 DELIMITED",
"placeless_element : reset_variables",
"placeless_element : RESET",
"macro_name : VARIABLE",
"macro_name : LABEL",
"reset_variables : RESET VARIABLE",
"reset_variables : reset_variables VARIABLE",
"reset_variables : reset_variables ',' VARIABLE",
"print_args : print_arg",
"print_args : print_args print_arg",
"print_arg : expr",
"print_arg : text",
"print_arg : position",
"$$8 :",
"simple_if : IF any_expr THEN $$8 DELIMITED",
"until :",
"until : UNTIL TEXT",
"any_expr : expr",
"any_expr : text_expr",
"text_expr : text EQUALEQUAL text",
"text_expr : text NOTEQUAL text",
"text_expr : text_expr ANDAND text_expr",
"text_expr : text_expr ANDAND expr",
"text_expr : expr ANDAND text_expr",
"text_expr : text_expr OROR text_expr",
"text_expr : text_expr OROR expr",
"text_expr : expr OROR text_expr",
"text_expr : '!' text_expr",
"optional_by :",
"optional_by : BY expr",
"optional_by : BY '*' expr",
"element : object_spec",
"element : LABEL ':' optional_separator element",
"element : LABEL ':' optional_separator position_not_place",
"element : LABEL ':' optional_separator place",
"$$9 :",
"$$10 :",
"element : '{' $$9 element_list '}' $$10 optional_element",
"element : placeless_element",
"optional_element :",
"optional_element : element",
"object_spec : BOX",
"object_spec : CIRCLE",
"object_spec : ELLIPSE",
"object_spec : ARC",
"object_spec : LINE",
"object_spec : ARROW",
"object_spec : MOVE",
"object_spec : SPLINE",
"object_spec : text",
"object_spec : PLOT expr",
"object_spec : PLOT expr text",
"$$11 :",
"object_spec : '[' $$11 element_list ']'",
"object_spec : object_spec HEIGHT expr",
"object_spec : object_spec RADIUS expr",
"object_spec : object_spec WIDTH expr",
"object_spec : object_spec DIAMETER expr",
"object_spec : object_spec expr",
"object_spec : object_spec UP",
"object_spec : object_spec UP expr",
"object_spec : object_spec DOWN",
"object_spec : object_spec DOWN expr",
"object_spec : object_spec RIGHT",
"object_spec : object_spec RIGHT expr",
"object_spec : object_spec LEFT",
"object_spec : object_spec LEFT expr",
"object_spec : object_spec FROM position",
"object_spec : object_spec TO position",
"object_spec : object_spec AT position",
"object_spec : object_spec WITH path",
"object_spec : object_spec WITH position",
"object_spec : object_spec BY expr_pair",
"object_spec : object_spec THEN",
"object_spec : object_spec SOLID",
"object_spec : object_spec DOTTED",
"object_spec : object_spec DOTTED expr",
"object_spec : object_spec DASHED",
"object_spec : object_spec DASHED expr",
"object_spec : object_spec FILL",
"object_spec : object_spec FILL expr",
"object_spec : object_spec XSLANTED expr",
"object_spec : object_spec YSLANTED expr",
"object_spec : object_spec SHADED text",
"object_spec : object_spec COLORED text",
"object_spec : object_spec OUTLINED text",
"object_spec : object_spec CHOP",
"object_spec : object_spec CHOP expr",
"object_spec : object_spec SAME",
"object_spec : object_spec INVISIBLE",
"object_spec : object_spec LEFT_ARROW_HEAD",
"object_spec : object_spec RIGHT_ARROW_HEAD",
"object_spec : object_spec DOUBLE_ARROW_HEAD",
"object_spec : object_spec CW",
"object_spec : object_spec CCW",
"object_spec : object_spec text",
"object_spec : object_spec LJUST",
"object_spec : object_spec RJUST",
"object_spec : object_spec ABOVE",
"object_spec : object_spec BELOW",
"object_spec : object_spec THICKNESS expr",
"object_spec : object_spec ALIGNED",
"text : TEXT",
"text : SPRINTF '(' TEXT sprintf_args ')'",
"sprintf_args :",
"sprintf_args : sprintf_args ',' expr",
"position : position_not_place",
"position : place",
"position : '(' place ')'",
"position_not_place : expr_pair",
"position_not_place : position '+' expr_pair",
"position_not_place : '(' position '+' expr_pair ')'",
"position_not_place : position '-' expr_pair",
"position_not_place : '(' position '-' expr_pair ')'",
"position_not_place : '(' position ',' position ')'",
"position_not_place : expr between position AND position",
"position_not_place : '(' expr between position AND position ')'",
"position_not_place : expr_not_lower_than '<' position ',' position '>'",
"position_not_place : '(' expr_not_lower_than '<' position ',' position '>' ')'",
"between : BETWEEN",
"between : OF THE WAY BETWEEN",
"expr_pair : expr ',' expr",
"expr_pair : '(' expr_pair ')'",
"place : label",
"place : label corner",
"place : corner label",
"place : corner OF label",
"place : HERE",
"label : LABEL",
"label : nth_primitive",
"label : label '.' LABEL",
"ordinal : ORDINAL",
"ordinal : '`' any_expr TH",
"optional_ordinal_last : LAST",
"optional_ordinal_last : ordinal LAST",
"nth_primitive : ordinal object_type",
"nth_primitive : optional_ordinal_last object_type",
"object_type : BOX",
"object_type : CIRCLE",
"object_type : ELLIPSE",
"object_type : ARC",
"object_type : LINE",
"object_type : ARROW",
"object_type : SPLINE",
"object_type : '[' ']'",
"object_type : TEXT",
"label_path : '.' LABEL",
"label_path : label_path '.' LABEL",
"relative_path : corner",
"relative_path : label_path",
"relative_path : label_path corner",
"path : relative_path",
"path : '(' relative_path ',' relative_path ')'",
"path : ORDINAL LAST object_type relative_path",
"path : LAST object_type relative_path",
"path : ORDINAL object_type relative_path",
"path : LABEL relative_path",
"corner : DOT_N",
"corner : DOT_E",
"corner : DOT_W",
"corner : DOT_S",
"corner : DOT_NE",
"corner : DOT_SE",
"corner : DOT_NW",
"corner : DOT_SW",
"corner : DOT_C",
"corner : DOT_START",
"corner : DOT_END",
"corner : TOP",
"corner : BOTTOM",
"corner : LEFT",
"corner : RIGHT",
"corner : UPPER LEFT",
"corner : LOWER LEFT",
"corner : UPPER RIGHT",
"corner : LOWER RIGHT",
"corner : LEFT_CORNER",
"corner : RIGHT_CORNER",
"corner : UPPER LEFT_CORNER",
"corner : LOWER LEFT_CORNER",
"corner : UPPER RIGHT_CORNER",
"corner : LOWER RIGHT_CORNER",
"corner : NORTH",
"corner : SOUTH",
"corner : EAST",
"corner : WEST",
"corner : CENTER",
"corner : START",
"corner : END",
"expr : expr_lower_than",
"expr : expr_not_lower_than",
"expr_lower_than : expr '<' expr",
"expr_not_lower_than : VARIABLE",
"expr_not_lower_than : NUMBER",
"expr_not_lower_than : place DOT_X",
"expr_not_lower_than : place DOT_Y",
"expr_not_lower_than : place DOT_HT",
"expr_not_lower_than : place DOT_WID",
"expr_not_lower_than : place DOT_RAD",
"expr_not_lower_than : expr '+' expr",
"expr_not_lower_than : expr '-' expr",
"expr_not_lower_than : expr '*' expr",
"expr_not_lower_than : expr '/' expr",
"expr_not_lower_than : expr '%' expr",
"expr_not_lower_than : expr '^' expr",
"expr_not_lower_than : '-' expr",
"expr_not_lower_than : '(' any_expr ')'",
"expr_not_lower_than : SIN '(' any_expr ')'",
"expr_not_lower_than : COS '(' any_expr ')'",
"expr_not_lower_than : ATAN2 '(' any_expr ',' any_expr ')'",
"expr_not_lower_than : LOG '(' any_expr ')'",
"expr_not_lower_than : EXP '(' any_expr ')'",
"expr_not_lower_than : SQRT '(' any_expr ')'",
"expr_not_lower_than : K_MAX '(' any_expr ',' any_expr ')'",
"expr_not_lower_than : K_MIN '(' any_expr ',' any_expr ')'",
"expr_not_lower_than : INT '(' any_expr ')'",
"expr_not_lower_than : RAND '(' any_expr ')'",
"expr_not_lower_than : RAND '(' ')'",
"expr_not_lower_than : SRAND '(' any_expr ')'",
"expr_not_lower_than : expr LESSEQUAL expr",
"expr_not_lower_than : expr '>' expr",
"expr_not_lower_than : expr GREATEREQUAL expr",
"expr_not_lower_than : expr EQUALEQUAL expr",
"expr_not_lower_than : expr NOTEQUAL expr",
"expr_not_lower_than : expr ANDAND expr",
"expr_not_lower_than : expr OROR expr",
"expr_not_lower_than : '!' expr",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 1678 "pic.y"

/* bison defines const to be empty unless __STDC__ is defined, which it
isn't under cfront */

#ifdef const
#undef const
#endif

static struct {
  const char *name;
  double val;
  int scaled;		     // non-zero if val should be multiplied by scale
} defaults_table[] = {
  { "arcrad", .25, 1 },
  { "arrowht", .1, 1 },
  { "arrowwid", .05, 1 },
  { "circlerad", .25, 1 },
  { "boxht", .5, 1 },
  { "boxwid", .75, 1 },
  { "boxrad", 0.0, 1 },
  { "dashwid", .05, 1 },
  { "ellipseht", .5, 1 },
  { "ellipsewid", .75, 1 },
  { "moveht", .5, 1 },
  { "movewid", .5, 1 },
  { "lineht", .5, 1 },
  { "linewid", .5, 1 },
  { "textht", 0.0, 1 },
  { "textwid", 0.0, 1 },
  { "scale", 1.0, 0 },
  { "linethick", -1.0, 0 },		// in points
  { "fillval", .5, 0 },
  { "arrowhead", 1.0, 0 },
  { "maxpswid", 8.5, 0 },
  { "maxpsht", 11.0, 0 },
};

place *lookup_label(const char *label)
{
  saved_state *state = current_saved_state;
  PTABLE(place) *tbl = current_table;
  for (;;) {
    place *pl = tbl->lookup(label);
    if (pl)
      return pl;
    if (!state)
      return 0;
    tbl = state->tbl;
    state = state->prev;
  }
}

void define_label(const char *label, const place *pl)
{
  place *p = new place[1];
  *p = *pl;
  current_table->define(label, p);
}

int lookup_variable(const char *name, double *val)
{
  place *pl = lookup_label(name);
  if (pl) {
    *val = pl->x;
    return 1;
  }
  return 0;
}

void define_variable(const char *name, double val)
{
  place *p = new place[1];
  p->obj = 0;
  p->x = val;
  p->y = 0.0;
  current_table->define(name, p);
  if (strcmp(name, "scale") == 0) {
    // When the scale changes, reset all scaled pre-defined variables to
    // their default values.
    for (unsigned int i = 0;
	 i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++) 
      if (defaults_table[i].scaled)
	define_variable(defaults_table[i].name, val*defaults_table[i].val);
  }
}

// called once only (not once per parse)

void parse_init()
{
  current_direction = RIGHT_DIRECTION;
  current_position.x = 0.0;
  current_position.y = 0.0;
  // This resets everything to its default value.
  reset_all();
}

void reset(const char *nm)
{
  for (unsigned int i = 0;
       i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
    if (strcmp(nm, defaults_table[i].name) == 0) {
      double val = defaults_table[i].val;
      if (defaults_table[i].scaled) {
	double scale;
	lookup_variable("scale", &scale);
	val *= scale;
      }
      define_variable(defaults_table[i].name, val);
      return;
    }
  lex_error("`%1' is not a predefined variable", nm);
}

void reset_all()
{
  // We only have to explicitly reset the pre-defined variables that
  // aren't scaled because `scale' is not scaled, and changing the
  // value of `scale' will reset all the pre-defined variables that
  // are scaled.
  for (unsigned int i = 0;
       i < sizeof(defaults_table)/sizeof(defaults_table[0]); i++)
    if (!defaults_table[i].scaled)
      define_variable(defaults_table[i].name, defaults_table[i].val);
}

// called after each parse

void parse_cleanup()
{
  while (current_saved_state != 0) {
    delete current_table;
    current_table = current_saved_state->tbl;
    saved_state *tem = current_saved_state;
    current_saved_state = current_saved_state->prev;
    delete tem;
  }
  assert(current_table == &top_table);
  PTABLE_ITERATOR(place) iter(current_table);
  const char *key;
  place *pl;
  while (iter.next(&key, &pl))
    if (pl->obj != 0) {
      position pos = pl->obj->origin();
      pl->obj = 0;
      pl->x = pos.x;
      pl->y = pos.y;
    }
  while (olist.head != 0) {
    object *tem = olist.head;
    olist.head = olist.head->next;
    delete tem;
  }
  olist.tail = 0;
  current_direction = RIGHT_DIRECTION;
  current_position.x = 0.0;
  current_position.y = 0.0;
}

const char *ordinal_postfix(int n)
{
  if (n < 10 || n > 20)
    switch (n % 10) {
    case 1:
      return "st";
    case 2:
      return "nd";
    case 3:
      return "rd";
    }
  return "th";
}

const char *object_type_name(object_type type)
{
  switch (type) {
  case BOX_OBJECT:
    return "box";
  case CIRCLE_OBJECT:
    return "circle";
  case ELLIPSE_OBJECT:
    return "ellipse";
  case ARC_OBJECT:
    return "arc";
  case SPLINE_OBJECT:
    return "spline";
  case LINE_OBJECT:
    return "line";
  case ARROW_OBJECT:
    return "arrow";
  case MOVE_OBJECT:
    return "move";
  case TEXT_OBJECT:
    return "\"\"";
  case BLOCK_OBJECT:
    return "[]";
  case OTHER_OBJECT:
  case MARK_OBJECT:
  default:
    break;
  }
  return "object";
}

static char sprintf_buf[1024];

char *format_number(const char *form, double n)
{
  if (form == 0)
    form = "%g";
  return do_sprintf(form, &n, 1);
}

char *do_sprintf(const char *form, const double *v, int nv)
{
  string result;
  int i = 0;
  string one_format;
  while (*form) {
    if (*form == '%') {
      one_format += *form++;
      for (; *form != '\0' && strchr("#-+ 0123456789.", *form) != 0; form++)
	one_format += *form;
      if (*form == '\0' || strchr("eEfgG%", *form) == 0) {
	lex_error("bad sprintf format");
	result += one_format;
	result += form;
	break;
      }
      if (*form == '%') {
	one_format += *form++;
	one_format += '\0';
	snprintf(sprintf_buf, sizeof(sprintf_buf),
		 "%s", one_format.contents());
      }
      else {
	if (i >= nv) {
	  lex_error("too few arguments to snprintf");
	  result += one_format;
	  result += form;
	  break;
	}
	one_format += *form++;
	one_format += '\0';
	snprintf(sprintf_buf, sizeof(sprintf_buf),
		 one_format.contents(), v[i++]);
      }
      one_format.clear();
      result += sprintf_buf;
    }
    else
      result += *form++;
  }
  result += '\0';
  return strsave(result.contents());
}
#line 4012 "pic.cpp"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 2:
#line 277 "pic.y"
	{
		  if (olist.head)
		    print_picture(olist.head);
		}
break;
case 3:
#line 286 "pic.y"
	{ yyval.pl = yystack.l_mark[-1].pl; }
break;
case 4:
#line 291 "pic.y"
	{ yyval.pl = yystack.l_mark[0].pl; }
break;
case 5:
#line 293 "pic.y"
	{ yyval.pl = yystack.l_mark[-2].pl; }
break;
case 10:
#line 308 "pic.y"
	{
		  a_delete graphname;
		  graphname = new char[strlen(yystack.l_mark[0].str) + 1];
		  strcpy(graphname, yystack.l_mark[0].str);
		  a_delete yystack.l_mark[0].str;
		}
break;
case 11:
#line 316 "pic.y"
	{
		  define_variable(yystack.l_mark[-2].str, yystack.l_mark[0].x);
		  a_delete yystack.l_mark[-2].str;
		}
break;
case 12:
#line 321 "pic.y"
	{
		  place *p = lookup_label(yystack.l_mark[-3].str);
		  if (!p) {
		    lex_error("variable `%1' not defined", yystack.l_mark[-3].str);
		    YYABORT;
		  }
		  p->obj = 0;
		  p->x = yystack.l_mark[0].x;
		  p->y = 0.0;
		  a_delete yystack.l_mark[-3].str;
		}
break;
case 13:
#line 333 "pic.y"
	{ current_direction = UP_DIRECTION; }
break;
case 14:
#line 335 "pic.y"
	{ current_direction = DOWN_DIRECTION; }
break;
case 15:
#line 337 "pic.y"
	{ current_direction = LEFT_DIRECTION; }
break;
case 16:
#line 339 "pic.y"
	{ current_direction = RIGHT_DIRECTION; }
break;
case 17:
#line 341 "pic.y"
	{
		  olist.append(make_command_object(yystack.l_mark[0].lstr.str, yystack.l_mark[0].lstr.filename,
						   yystack.l_mark[0].lstr.lineno));
		}
break;
case 18:
#line 346 "pic.y"
	{
		  olist.append(make_command_object(yystack.l_mark[0].lstr.str, yystack.l_mark[0].lstr.filename,
						   yystack.l_mark[0].lstr.lineno));
		}
break;
case 19:
#line 351 "pic.y"
	{
		  fprintf(stderr, "%s\n", yystack.l_mark[0].lstr.str);
		  a_delete yystack.l_mark[0].lstr.str;
		  fflush(stderr);
		}
break;
case 20:
#line 357 "pic.y"
	{ delim_flag = 1; }
break;
case 21:
#line 359 "pic.y"
	{
		  delim_flag = 0;
		  if (safer_flag)
		    lex_error("unsafe to run command `%1'", yystack.l_mark[0].str);
		  else
		    system(yystack.l_mark[0].str);
		  a_delete yystack.l_mark[0].str;
		}
break;
case 22:
#line 368 "pic.y"
	{
		  if (yychar < 0)
		    do_lookahead();
		  do_copy(yystack.l_mark[0].lstr.str);
		  /* do not delete the filename*/
		}
break;
case 23:
#line 375 "pic.y"
	{ delim_flag = 2; }
break;
case 24:
#line 377 "pic.y"
	{ delim_flag = 0; }
break;
case 25:
#line 379 "pic.y"
	{
		  if (yychar < 0)
		    do_lookahead();
		  copy_file_thru(yystack.l_mark[-5].lstr.str, yystack.l_mark[-2].str, yystack.l_mark[0].str);
		  /* do not delete the filename*/
		  a_delete yystack.l_mark[-2].str;
		  a_delete yystack.l_mark[0].str;
		}
break;
case 26:
#line 388 "pic.y"
	{ delim_flag = 2; }
break;
case 27:
#line 390 "pic.y"
	{ delim_flag = 0; }
break;
case 28:
#line 392 "pic.y"
	{
		  if (yychar < 0)
		    do_lookahead();
		  copy_rest_thru(yystack.l_mark[-2].str, yystack.l_mark[0].str);
		  a_delete yystack.l_mark[-2].str;
		  a_delete yystack.l_mark[0].str;
		}
break;
case 29:
#line 400 "pic.y"
	{ delim_flag = 1; }
break;
case 30:
#line 402 "pic.y"
	{
		  delim_flag = 0;
		  if (yychar < 0)
		    do_lookahead();
		  do_for(yystack.l_mark[-8].str, yystack.l_mark[-6].x, yystack.l_mark[-4].x, yystack.l_mark[-3].by.is_multiplicative, yystack.l_mark[-3].by.val, yystack.l_mark[0].str); 
		}
break;
case 31:
#line 409 "pic.y"
	{
		  if (yychar < 0)
		    do_lookahead();
		  if (yystack.l_mark[0].if_data.x != 0.0)
		    push_body(yystack.l_mark[0].if_data.body);
		  a_delete yystack.l_mark[0].if_data.body;
		}
break;
case 32:
#line 417 "pic.y"
	{ delim_flag = 1; }
break;
case 33:
#line 419 "pic.y"
	{
		  delim_flag = 0;
		  if (yychar < 0)
		    do_lookahead();
		  if (yystack.l_mark[-3].if_data.x != 0.0)
		    push_body(yystack.l_mark[-3].if_data.body);
		  else
		    push_body(yystack.l_mark[0].str);
		  a_delete yystack.l_mark[-3].if_data.body;
		  a_delete yystack.l_mark[0].str;
		}
break;
case 35:
#line 432 "pic.y"
	{ define_variable("scale", 1.0); }
break;
case 38:
#line 442 "pic.y"
	{
		  reset(yystack.l_mark[0].str);
		  a_delete yystack.l_mark[0].str;
		}
break;
case 39:
#line 447 "pic.y"
	{
		  reset(yystack.l_mark[0].str);
		  a_delete yystack.l_mark[0].str;
		}
break;
case 40:
#line 452 "pic.y"
	{
		  reset(yystack.l_mark[0].str);
		  a_delete yystack.l_mark[0].str;
		}
break;
case 41:
#line 460 "pic.y"
	{ yyval.lstr = yystack.l_mark[0].lstr; }
break;
case 42:
#line 462 "pic.y"
	{
		  yyval.lstr.str = new char[strlen(yystack.l_mark[-1].lstr.str) + strlen(yystack.l_mark[0].lstr.str) + 1];
		  strcpy(yyval.lstr.str, yystack.l_mark[-1].lstr.str);
		  strcat(yyval.lstr.str, yystack.l_mark[0].lstr.str);
		  a_delete yystack.l_mark[-1].lstr.str;
		  a_delete yystack.l_mark[0].lstr.str;
		  if (yystack.l_mark[-1].lstr.filename) {
		    yyval.lstr.filename = yystack.l_mark[-1].lstr.filename;
		    yyval.lstr.lineno = yystack.l_mark[-1].lstr.lineno;
		  }
		  else if (yystack.l_mark[0].lstr.filename) {
		    yyval.lstr.filename = yystack.l_mark[0].lstr.filename;
		    yyval.lstr.lineno = yystack.l_mark[0].lstr.lineno;
		  }
		}
break;
case 43:
#line 481 "pic.y"
	{
		  yyval.lstr.str = new char[GDIGITS + 1];
		  sprintf(yyval.lstr.str, "%g", yystack.l_mark[0].x);
		  yyval.lstr.filename = 0;
		  yyval.lstr.lineno = 0;
		}
break;
case 44:
#line 488 "pic.y"
	{ yyval.lstr = yystack.l_mark[0].lstr; }
break;
case 45:
#line 490 "pic.y"
	{
		  yyval.lstr.str = new char[GDIGITS + 2 + GDIGITS + 1];
		  sprintf(yyval.lstr.str, "%g, %g", yystack.l_mark[0].pair.x, yystack.l_mark[0].pair.y);
		  yyval.lstr.filename = 0;
		  yyval.lstr.lineno = 0;
		}
break;
case 46:
#line 500 "pic.y"
	{ delim_flag = 1; }
break;
case 47:
#line 502 "pic.y"
	{
		  delim_flag = 0;
		  yyval.if_data.x = yystack.l_mark[-3].x;
		  yyval.if_data.body = yystack.l_mark[0].str;
		}
break;
case 48:
#line 511 "pic.y"
	{ yyval.str = 0; }
break;
case 49:
#line 513 "pic.y"
	{ yyval.str = yystack.l_mark[0].lstr.str; }
break;
case 50:
#line 518 "pic.y"
	{ yyval.x = yystack.l_mark[0].x; }
break;
case 51:
#line 520 "pic.y"
	{ yyval.x = yystack.l_mark[0].x; }
break;
case 52:
#line 525 "pic.y"
	{
		  yyval.x = strcmp(yystack.l_mark[-2].lstr.str, yystack.l_mark[0].lstr.str) == 0;
		  a_delete yystack.l_mark[-2].lstr.str;
		  a_delete yystack.l_mark[0].lstr.str;
		}
break;
case 53:
#line 531 "pic.y"
	{
		  yyval.x = strcmp(yystack.l_mark[-2].lstr.str, yystack.l_mark[0].lstr.str) != 0;
		  a_delete yystack.l_mark[-2].lstr.str;
		  a_delete yystack.l_mark[0].lstr.str;
		}
break;
case 54:
#line 537 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 && yystack.l_mark[0].x != 0.0); }
break;
case 55:
#line 539 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 && yystack.l_mark[0].x != 0.0); }
break;
case 56:
#line 541 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 && yystack.l_mark[0].x != 0.0); }
break;
case 57:
#line 543 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 || yystack.l_mark[0].x != 0.0); }
break;
case 58:
#line 545 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 || yystack.l_mark[0].x != 0.0); }
break;
case 59:
#line 547 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 || yystack.l_mark[0].x != 0.0); }
break;
case 60:
#line 549 "pic.y"
	{ yyval.x = (yystack.l_mark[0].x == 0.0); }
break;
case 61:
#line 555 "pic.y"
	{
		  yyval.by.val = 1.0;
		  yyval.by.is_multiplicative = 0;
		}
break;
case 62:
#line 560 "pic.y"
	{
		  yyval.by.val = yystack.l_mark[0].x;
		  yyval.by.is_multiplicative = 0;
		}
break;
case 63:
#line 565 "pic.y"
	{
		  yyval.by.val = yystack.l_mark[0].x;
		  yyval.by.is_multiplicative = 1;
		}
break;
case 64:
#line 573 "pic.y"
	{
		  yyval.pl.obj = yystack.l_mark[0].spec->make_object(&current_position,
					   &current_direction);
		  if (yyval.pl.obj == 0)
		    YYABORT;
		  delete yystack.l_mark[0].spec;
		  if (yyval.pl.obj)
		    olist.append(yyval.pl.obj);
		  else {
		    yyval.pl.x = current_position.x;
		    yyval.pl.y = current_position.y;
		  }
		}
break;
case 65:
#line 587 "pic.y"
	{
		  yyval.pl = yystack.l_mark[0].pl;
		  define_label(yystack.l_mark[-3].str, & yyval.pl);
		  a_delete yystack.l_mark[-3].str;
		}
break;
case 66:
#line 593 "pic.y"
	{
		  yyval.pl.obj = 0;
		  yyval.pl.x = yystack.l_mark[0].pair.x;
		  yyval.pl.y = yystack.l_mark[0].pair.y;
		  define_label(yystack.l_mark[-3].str, & yyval.pl);
		  a_delete yystack.l_mark[-3].str;
		}
break;
case 67:
#line 601 "pic.y"
	{
		  yyval.pl = yystack.l_mark[0].pl;
		  define_label(yystack.l_mark[-3].str, & yyval.pl);
		  a_delete yystack.l_mark[-3].str;
		}
break;
case 68:
#line 607 "pic.y"
	{
		  yyval.state.x = current_position.x;
		  yyval.state.y = current_position.y;
		  yyval.state.dir = current_direction;
		}
break;
case 69:
#line 613 "pic.y"
	{
		  current_position.x = yystack.l_mark[-2].state.x;
		  current_position.y = yystack.l_mark[-2].state.y;
		  current_direction = yystack.l_mark[-2].state.dir;
		}
break;
case 70:
#line 619 "pic.y"
	{
		  yyval.pl = yystack.l_mark[-3].pl;
		}
break;
case 71:
#line 623 "pic.y"
	{
		  yyval.pl.obj = 0;
		  yyval.pl.x = current_position.x;
		  yyval.pl.y = current_position.y;
		}
break;
case 72:
#line 632 "pic.y"
	{}
break;
case 73:
#line 634 "pic.y"
	{}
break;
case 74:
#line 639 "pic.y"
	{ yyval.spec = new object_spec(BOX_OBJECT); }
break;
case 75:
#line 641 "pic.y"
	{ yyval.spec = new object_spec(CIRCLE_OBJECT); }
break;
case 76:
#line 643 "pic.y"
	{ yyval.spec = new object_spec(ELLIPSE_OBJECT); }
break;
case 77:
#line 645 "pic.y"
	{
		  yyval.spec = new object_spec(ARC_OBJECT);
		  yyval.spec->dir = current_direction;
		}
break;
case 78:
#line 650 "pic.y"
	{
		  yyval.spec = new object_spec(LINE_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		}
break;
case 79:
#line 657 "pic.y"
	{
		  yyval.spec = new object_spec(ARROW_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		}
break;
case 80:
#line 664 "pic.y"
	{
		  yyval.spec = new object_spec(MOVE_OBJECT);
		  lookup_variable("moveht", & yyval.spec->segment_height);
		  lookup_variable("movewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		}
break;
case 81:
#line 671 "pic.y"
	{
		  yyval.spec = new object_spec(SPLINE_OBJECT);
		  lookup_variable("lineht", & yyval.spec->segment_height);
		  lookup_variable("linewid", & yyval.spec->segment_width);
		  yyval.spec->dir = current_direction;
		}
break;
case 82:
#line 678 "pic.y"
	{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(yystack.l_mark[0].lstr.str, yystack.l_mark[0].lstr.filename, yystack.l_mark[0].lstr.lineno);
		}
break;
case 83:
#line 683 "pic.y"
	{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(format_number(0, yystack.l_mark[0].x), 0, -1);
		}
break;
case 84:
#line 688 "pic.y"
	{
		  yyval.spec = new object_spec(TEXT_OBJECT);
		  yyval.spec->text = new text_item(format_number(yystack.l_mark[0].lstr.str, yystack.l_mark[-1].x),
					   yystack.l_mark[0].lstr.filename, yystack.l_mark[0].lstr.lineno);
		  a_delete yystack.l_mark[0].lstr.str;
		}
break;
case 85:
#line 695 "pic.y"
	{
		  saved_state *p = new saved_state;
		  yyval.pstate = p;
		  p->x = current_position.x;
		  p->y = current_position.y;
		  p->dir = current_direction;
		  p->tbl = current_table;
		  p->prev = current_saved_state;
		  current_position.x = 0.0;
		  current_position.y = 0.0;
		  current_table = new PTABLE(place);
		  current_saved_state = p;
		  olist.append(make_mark_object());
		}
break;
case 86:
#line 710 "pic.y"
	{
		  current_position.x = yystack.l_mark[-2].pstate->x;
		  current_position.y = yystack.l_mark[-2].pstate->y;
		  current_direction = yystack.l_mark[-2].pstate->dir;
		  yyval.spec = new object_spec(BLOCK_OBJECT);
		  olist.wrap_up_block(& yyval.spec->oblist);
		  yyval.spec->tbl = current_table;
		  current_table = yystack.l_mark[-2].pstate->tbl;
		  current_saved_state = yystack.l_mark[-2].pstate->prev;
		  delete yystack.l_mark[-2].pstate;
		}
break;
case 87:
#line 722 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->height = yystack.l_mark[0].x;
		  yyval.spec->flags |= HAS_HEIGHT;
		}
break;
case 88:
#line 728 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->radius = yystack.l_mark[0].x;
		  yyval.spec->flags |= HAS_RADIUS;
		}
break;
case 89:
#line 734 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->width = yystack.l_mark[0].x;
		  yyval.spec->flags |= HAS_WIDTH;
		}
break;
case 90:
#line 740 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->radius = yystack.l_mark[0].x/2.0;
		  yyval.spec->flags |= HAS_RADIUS;
		}
break;
case 91:
#line 746 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= HAS_SEGMENT;
		  switch (yyval.spec->dir) {
		  case UP_DIRECTION:
		    yyval.spec->segment_pos.y += yystack.l_mark[0].x;
		    break;
		  case DOWN_DIRECTION:
		    yyval.spec->segment_pos.y -= yystack.l_mark[0].x;
		    break;
		  case RIGHT_DIRECTION:
		    yyval.spec->segment_pos.x += yystack.l_mark[0].x;
		    break;
		  case LEFT_DIRECTION:
		    yyval.spec->segment_pos.x -= yystack.l_mark[0].x;
		    break;
		  }
		}
break;
case 92:
#line 765 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->dir = UP_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y += yyval.spec->segment_height;
		}
break;
case 93:
#line 772 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->dir = UP_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y += yystack.l_mark[0].x;
		}
break;
case 94:
#line 779 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->dir = DOWN_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y -= yyval.spec->segment_height;
		}
break;
case 95:
#line 786 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->dir = DOWN_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.y -= yystack.l_mark[0].x;
		}
break;
case 96:
#line 793 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->dir = RIGHT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yyval.spec->segment_width;
		}
break;
case 97:
#line 800 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->dir = RIGHT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yystack.l_mark[0].x;
		}
break;
case 98:
#line 807 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->dir = LEFT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x -= yyval.spec->segment_width;
		}
break;
case 99:
#line 814 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->dir = LEFT_DIRECTION;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x -= yystack.l_mark[0].x;
		}
break;
case 100:
#line 821 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= HAS_FROM;
		  yyval.spec->from.x = yystack.l_mark[0].pair.x;
		  yyval.spec->from.y = yystack.l_mark[0].pair.y;
		}
break;
case 101:
#line 828 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  if (yyval.spec->flags & HAS_SEGMENT)
		    yyval.spec->segment_list = new segment(yyval.spec->segment_pos,
						   yyval.spec->segment_is_absolute,
						   yyval.spec->segment_list);
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x = yystack.l_mark[0].pair.x;
		  yyval.spec->segment_pos.y = yystack.l_mark[0].pair.y;
		  yyval.spec->segment_is_absolute = 1;
		  yyval.spec->flags |= HAS_TO;
		  yyval.spec->to.x = yystack.l_mark[0].pair.x;
		  yyval.spec->to.y = yystack.l_mark[0].pair.y;
		}
break;
case 102:
#line 843 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= HAS_AT;
		  yyval.spec->at.x = yystack.l_mark[0].pair.x;
		  yyval.spec->at.y = yystack.l_mark[0].pair.y;
		  if (yyval.spec->type != ARC_OBJECT) {
		    yyval.spec->flags |= HAS_FROM;
		    yyval.spec->from.x = yystack.l_mark[0].pair.x;
		    yyval.spec->from.y = yystack.l_mark[0].pair.y;
		  }
		}
break;
case 103:
#line 855 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= HAS_WITH;
		  yyval.spec->with = yystack.l_mark[0].pth;
		}
break;
case 104:
#line 861 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= HAS_WITH;
		  position pos;
		  pos.x = yystack.l_mark[0].pair.x;
		  pos.y = yystack.l_mark[0].pair.y;
		  yyval.spec->with = new path(pos);
		}
break;
case 105:
#line 870 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= HAS_SEGMENT;
		  yyval.spec->segment_pos.x += yystack.l_mark[0].pair.x;
		  yyval.spec->segment_pos.y += yystack.l_mark[0].pair.y;
		}
break;
case 106:
#line 877 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  if (!(yyval.spec->flags & HAS_SEGMENT))
		    switch (yyval.spec->dir) {
		    case UP_DIRECTION:
		      yyval.spec->segment_pos.y += yyval.spec->segment_width;
		      break;
		    case DOWN_DIRECTION:
		      yyval.spec->segment_pos.y -= yyval.spec->segment_width;
		      break;
		    case RIGHT_DIRECTION:
		      yyval.spec->segment_pos.x += yyval.spec->segment_width;
		      break;
		    case LEFT_DIRECTION:
		      yyval.spec->segment_pos.x -= yyval.spec->segment_width;
		      break;
		    }
		  yyval.spec->segment_list = new segment(yyval.spec->segment_pos,
						 yyval.spec->segment_is_absolute,
						 yyval.spec->segment_list);
		  yyval.spec->flags &= ~HAS_SEGMENT;
		  yyval.spec->segment_pos.x = yyval.spec->segment_pos.y = 0.0;
		  yyval.spec->segment_is_absolute = 0;
		}
break;
case 107:
#line 902 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;	/* nothing*/
		}
break;
case 108:
#line 906 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_DOTTED;
		  lookup_variable("dashwid", & yyval.spec->dash_width);
		}
break;
case 109:
#line 912 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= IS_DOTTED;
		  yyval.spec->dash_width = yystack.l_mark[0].x;
		}
break;
case 110:
#line 918 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_DASHED;
		  lookup_variable("dashwid", & yyval.spec->dash_width);
		}
break;
case 111:
#line 924 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= IS_DASHED;
		  yyval.spec->dash_width = yystack.l_mark[0].x;
		}
break;
case 112:
#line 930 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_DEFAULT_FILLED;
		}
break;
case 113:
#line 935 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= IS_FILLED;
		  yyval.spec->fill = yystack.l_mark[0].x;
		}
break;
case 114:
#line 941 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= IS_XSLANTED;
		  yyval.spec->xslanted = yystack.l_mark[0].x;
		}
break;
case 115:
#line 947 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= IS_YSLANTED;
		  yyval.spec->yslanted = yystack.l_mark[0].x;
		}
break;
case 116:
#line 953 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= (IS_SHADED | IS_FILLED);
		  yyval.spec->shaded = new char[strlen(yystack.l_mark[0].lstr.str)+1];
		  strcpy(yyval.spec->shaded, yystack.l_mark[0].lstr.str);
		}
break;
case 117:
#line 960 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= (IS_SHADED | IS_OUTLINED | IS_FILLED);
		  yyval.spec->shaded = new char[strlen(yystack.l_mark[0].lstr.str)+1];
		  strcpy(yyval.spec->shaded, yystack.l_mark[0].lstr.str);
		  yyval.spec->outlined = new char[strlen(yystack.l_mark[0].lstr.str)+1];
		  strcpy(yyval.spec->outlined, yystack.l_mark[0].lstr.str);
		}
break;
case 118:
#line 969 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= IS_OUTLINED;
		  yyval.spec->outlined = new char[strlen(yystack.l_mark[0].lstr.str)+1];
		  strcpy(yyval.spec->outlined, yystack.l_mark[0].lstr.str);
		}
break;
case 119:
#line 976 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  /* line chop chop means line chop 0 chop 0*/
		  if (yyval.spec->flags & IS_DEFAULT_CHOPPED) {
		    yyval.spec->flags |= IS_CHOPPED;
		    yyval.spec->flags &= ~IS_DEFAULT_CHOPPED;
		    yyval.spec->start_chop = yyval.spec->end_chop = 0.0;
		  }
		  else if (yyval.spec->flags & IS_CHOPPED) {
		    yyval.spec->end_chop = 0.0;
		  }
		  else {
		    yyval.spec->flags |= IS_DEFAULT_CHOPPED;
		  }
		}
break;
case 120:
#line 992 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  if (yyval.spec->flags & IS_DEFAULT_CHOPPED) {
		    yyval.spec->flags |= IS_CHOPPED;
		    yyval.spec->flags &= ~IS_DEFAULT_CHOPPED;
		    yyval.spec->start_chop = 0.0;
		    yyval.spec->end_chop = yystack.l_mark[0].x;
		  }
		  else if (yyval.spec->flags & IS_CHOPPED) {
		    yyval.spec->end_chop = yystack.l_mark[0].x;
		  }
		  else {
		    yyval.spec->start_chop = yyval.spec->end_chop = yystack.l_mark[0].x;
		    yyval.spec->flags |= IS_CHOPPED;
		  }
		}
break;
case 121:
#line 1009 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_SAME;
		}
break;
case 122:
#line 1014 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_INVISIBLE;
		}
break;
case 123:
#line 1019 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= HAS_LEFT_ARROW_HEAD;
		}
break;
case 124:
#line 1024 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= HAS_RIGHT_ARROW_HEAD;
		}
break;
case 125:
#line 1029 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= (HAS_LEFT_ARROW_HEAD|HAS_RIGHT_ARROW_HEAD);
		}
break;
case 126:
#line 1034 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_CLOCKWISE;
		}
break;
case 127:
#line 1039 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags &= ~IS_CLOCKWISE;
		}
break;
case 128:
#line 1044 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  text_item **p;
		  for (p = & yyval.spec->text; *p; p = &(*p)->next)
		    ;
		  *p = new text_item(yystack.l_mark[0].lstr.str, yystack.l_mark[0].lstr.filename, yystack.l_mark[0].lstr.lineno);
		}
break;
case 129:
#line 1052 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  if (yyval.spec->text) {
		    text_item *p;
		    for (p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.h = LEFT_ADJUST;
		  }
		}
break;
case 130:
#line 1062 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  if (yyval.spec->text) {
		    text_item *p;
		    for (p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.h = RIGHT_ADJUST;
		  }
		}
break;
case 131:
#line 1072 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  if (yyval.spec->text) {
		    text_item *p;
		    for (p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.v = ABOVE_ADJUST;
		  }
		}
break;
case 132:
#line 1082 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  if (yyval.spec->text) {
		    text_item *p;
		    for (p = yyval.spec->text; p->next; p = p->next)
		      ;
		    p->adj.v = BELOW_ADJUST;
		  }
		}
break;
case 133:
#line 1092 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-2].spec;
		  yyval.spec->flags |= HAS_THICKNESS;
		  yyval.spec->thickness = yystack.l_mark[0].x;
		}
break;
case 134:
#line 1098 "pic.y"
	{
		  yyval.spec = yystack.l_mark[-1].spec;
		  yyval.spec->flags |= IS_ALIGNED;
		}
break;
case 135:
#line 1106 "pic.y"
	{ yyval.lstr = yystack.l_mark[0].lstr; }
break;
case 136:
#line 1108 "pic.y"
	{
		  yyval.lstr.filename = yystack.l_mark[-2].lstr.filename;
		  yyval.lstr.lineno = yystack.l_mark[-2].lstr.lineno;
		  yyval.lstr.str = do_sprintf(yystack.l_mark[-2].lstr.str, yystack.l_mark[-1].dv.v, yystack.l_mark[-1].dv.nv);
		  a_delete yystack.l_mark[-1].dv.v;
		  a_delete yystack.l_mark[-2].lstr.str;
		}
break;
case 137:
#line 1119 "pic.y"
	{
		  yyval.dv.v = 0;
		  yyval.dv.nv = 0;
		  yyval.dv.maxv = 0;
		}
break;
case 138:
#line 1125 "pic.y"
	{
		  yyval.dv = yystack.l_mark[-2].dv;
		  if (yyval.dv.nv >= yyval.dv.maxv) {
		    if (yyval.dv.nv == 0) {
		      yyval.dv.v = new double[4];
		      yyval.dv.maxv = 4;
		    }
		    else {
		      double *oldv = yyval.dv.v;
		      yyval.dv.maxv *= 2;
#if 0
		      yyval.dv.v = new double[yyval.dv.maxv];
		      memcpy(yyval.dv.v, oldv, yyval.dv.nv*sizeof(double));
#else
		      /* workaround for bug in Compaq C++ V6.5-033*/
		      /* for Compaq Tru64 UNIX V5.1A (Rev. 1885)*/
		      double *foo = new double[yyval.dv.maxv];
		      memcpy(foo, oldv, yyval.dv.nv*sizeof(double));
		      yyval.dv.v = foo;
#endif
		      a_delete oldv;
		    }
		  }
		  yyval.dv.v[yyval.dv.nv] = yystack.l_mark[0].x;
		  yyval.dv.nv += 1;
		}
break;
case 139:
#line 1155 "pic.y"
	{ yyval.pair = yystack.l_mark[0].pair; }
break;
case 140:
#line 1157 "pic.y"
	{
		  position pos = yystack.l_mark[0].pl;
		  yyval.pair.x = pos.x;
		  yyval.pair.y = pos.y;
		}
break;
case 141:
#line 1163 "pic.y"
	{
		  position pos = yystack.l_mark[-1].pl;
		  yyval.pair.x = pos.x;
		  yyval.pair.y = pos.y;
		}
break;
case 142:
#line 1172 "pic.y"
	{ yyval.pair = yystack.l_mark[0].pair; }
break;
case 143:
#line 1174 "pic.y"
	{
		  yyval.pair.x = yystack.l_mark[-2].pair.x + yystack.l_mark[0].pair.x;
		  yyval.pair.y = yystack.l_mark[-2].pair.y + yystack.l_mark[0].pair.y;
		}
break;
case 144:
#line 1179 "pic.y"
	{
		  yyval.pair.x = yystack.l_mark[-3].pair.x + yystack.l_mark[-1].pair.x;
		  yyval.pair.y = yystack.l_mark[-3].pair.y + yystack.l_mark[-1].pair.y;
		}
break;
case 145:
#line 1184 "pic.y"
	{
		  yyval.pair.x = yystack.l_mark[-2].pair.x - yystack.l_mark[0].pair.x;
		  yyval.pair.y = yystack.l_mark[-2].pair.y - yystack.l_mark[0].pair.y;
		}
break;
case 146:
#line 1189 "pic.y"
	{
		  yyval.pair.x = yystack.l_mark[-3].pair.x - yystack.l_mark[-1].pair.x;
		  yyval.pair.y = yystack.l_mark[-3].pair.y - yystack.l_mark[-1].pair.y;
		}
break;
case 147:
#line 1194 "pic.y"
	{
		  yyval.pair.x = yystack.l_mark[-3].pair.x;
		  yyval.pair.y = yystack.l_mark[-1].pair.y;
		}
break;
case 148:
#line 1199 "pic.y"
	{
		  yyval.pair.x = (1.0 - yystack.l_mark[-4].x)*yystack.l_mark[-2].pair.x + yystack.l_mark[-4].x*yystack.l_mark[0].pair.x;
		  yyval.pair.y = (1.0 - yystack.l_mark[-4].x)*yystack.l_mark[-2].pair.y + yystack.l_mark[-4].x*yystack.l_mark[0].pair.y;
		}
break;
case 149:
#line 1204 "pic.y"
	{
		  yyval.pair.x = (1.0 - yystack.l_mark[-5].x)*yystack.l_mark[-3].pair.x + yystack.l_mark[-5].x*yystack.l_mark[-1].pair.x;
		  yyval.pair.y = (1.0 - yystack.l_mark[-5].x)*yystack.l_mark[-3].pair.y + yystack.l_mark[-5].x*yystack.l_mark[-1].pair.y;
		}
break;
case 150:
#line 1210 "pic.y"
	{
		  yyval.pair.x = (1.0 - yystack.l_mark[-5].x)*yystack.l_mark[-3].pair.x + yystack.l_mark[-5].x*yystack.l_mark[-1].pair.x;
		  yyval.pair.y = (1.0 - yystack.l_mark[-5].x)*yystack.l_mark[-3].pair.y + yystack.l_mark[-5].x*yystack.l_mark[-1].pair.y;
		}
break;
case 151:
#line 1215 "pic.y"
	{
		  yyval.pair.x = (1.0 - yystack.l_mark[-6].x)*yystack.l_mark[-4].pair.x + yystack.l_mark[-6].x*yystack.l_mark[-2].pair.x;
		  yyval.pair.y = (1.0 - yystack.l_mark[-6].x)*yystack.l_mark[-4].pair.y + yystack.l_mark[-6].x*yystack.l_mark[-2].pair.y;
		}
break;
case 154:
#line 1228 "pic.y"
	{
		  yyval.pair.x = yystack.l_mark[-2].x;
		  yyval.pair.y = yystack.l_mark[0].x;
		}
break;
case 155:
#line 1233 "pic.y"
	{ yyval.pair = yystack.l_mark[-1].pair; }
break;
case 156:
#line 1239 "pic.y"
	{ yyval.pl = yystack.l_mark[0].pl; }
break;
case 157:
#line 1241 "pic.y"
	{
		  path pth(yystack.l_mark[0].crn);
		  if (!pth.follow(yystack.l_mark[-1].pl, & yyval.pl))
		    YYABORT;
		}
break;
case 158:
#line 1247 "pic.y"
	{
		  path pth(yystack.l_mark[-1].crn);
		  if (!pth.follow(yystack.l_mark[0].pl, & yyval.pl))
		    YYABORT;
		}
break;
case 159:
#line 1253 "pic.y"
	{
		  path pth(yystack.l_mark[-2].crn);
		  if (!pth.follow(yystack.l_mark[0].pl, & yyval.pl))
		    YYABORT;
		}
break;
case 160:
#line 1259 "pic.y"
	{
		  yyval.pl.x = current_position.x;
		  yyval.pl.y = current_position.y;
		  yyval.pl.obj = 0;
		}
break;
case 161:
#line 1268 "pic.y"
	{
		  place *p = lookup_label(yystack.l_mark[0].str);
		  if (!p) {
		    lex_error("there is no place `%1'", yystack.l_mark[0].str);
		    YYABORT;
		  }
		  yyval.pl = *p;
		  a_delete yystack.l_mark[0].str;
		}
break;
case 162:
#line 1278 "pic.y"
	{ yyval.pl.obj = yystack.l_mark[0].obj; }
break;
case 163:
#line 1280 "pic.y"
	{
		  path pth(yystack.l_mark[0].str);
		  if (!pth.follow(yystack.l_mark[-2].pl, & yyval.pl))
		    YYABORT;
		}
break;
case 164:
#line 1289 "pic.y"
	{ yyval.n = yystack.l_mark[0].n; }
break;
case 165:
#line 1291 "pic.y"
	{
		  /* XXX Check for overflow (and non-integers?).*/
		  yyval.n = (int)yystack.l_mark[-1].x;
		}
break;
case 166:
#line 1299 "pic.y"
	{ yyval.n = 1; }
break;
case 167:
#line 1301 "pic.y"
	{ yyval.n = yystack.l_mark[-1].n; }
break;
case 168:
#line 1306 "pic.y"
	{
		  int count = 0;
		  object *p;
		  for (p = olist.head; p != 0; p = p->next)
		    if (p->type() == yystack.l_mark[0].obtype && ++count == yystack.l_mark[-1].n) {
		      yyval.obj = p;
		      break;
		    }
		  if (p == 0) {
		    lex_error("there is no %1%2 %3", yystack.l_mark[-1].n, ordinal_postfix(yystack.l_mark[-1].n),
			      object_type_name(yystack.l_mark[0].obtype));
		    YYABORT;
		  }
		}
break;
case 169:
#line 1321 "pic.y"
	{
		  int count = 0;
		  object *p;
		  for (p = olist.tail; p != 0; p = p->prev)
		    if (p->type() == yystack.l_mark[0].obtype && ++count == yystack.l_mark[-1].n) {
		      yyval.obj = p;
		      break;
		    }
		  if (p == 0) {
		    lex_error("there is no %1%2 last %3", yystack.l_mark[-1].n,
			      ordinal_postfix(yystack.l_mark[-1].n), object_type_name(yystack.l_mark[0].obtype));
		    YYABORT;
		  }
		}
break;
case 170:
#line 1339 "pic.y"
	{ yyval.obtype = BOX_OBJECT; }
break;
case 171:
#line 1341 "pic.y"
	{ yyval.obtype = CIRCLE_OBJECT; }
break;
case 172:
#line 1343 "pic.y"
	{ yyval.obtype = ELLIPSE_OBJECT; }
break;
case 173:
#line 1345 "pic.y"
	{ yyval.obtype = ARC_OBJECT; }
break;
case 174:
#line 1347 "pic.y"
	{ yyval.obtype = LINE_OBJECT; }
break;
case 175:
#line 1349 "pic.y"
	{ yyval.obtype = ARROW_OBJECT; }
break;
case 176:
#line 1351 "pic.y"
	{ yyval.obtype = SPLINE_OBJECT; }
break;
case 177:
#line 1353 "pic.y"
	{ yyval.obtype = BLOCK_OBJECT; }
break;
case 178:
#line 1355 "pic.y"
	{ yyval.obtype = TEXT_OBJECT; }
break;
case 179:
#line 1360 "pic.y"
	{ yyval.pth = new path(yystack.l_mark[0].str); }
break;
case 180:
#line 1362 "pic.y"
	{
		  yyval.pth = yystack.l_mark[-2].pth;
		  yyval.pth->append(yystack.l_mark[0].str);
		}
break;
case 181:
#line 1370 "pic.y"
	{ yyval.pth = new path(yystack.l_mark[0].crn); }
break;
case 182:
#line 1374 "pic.y"
	{ yyval.pth = yystack.l_mark[0].pth; }
break;
case 183:
#line 1376 "pic.y"
	{
		  yyval.pth = yystack.l_mark[-1].pth;
		  yyval.pth->append(yystack.l_mark[0].crn);
		}
break;
case 184:
#line 1384 "pic.y"
	{ yyval.pth = yystack.l_mark[0].pth; }
break;
case 185:
#line 1386 "pic.y"
	{
		  yyval.pth = yystack.l_mark[-3].pth;
		  yyval.pth->set_ypath(yystack.l_mark[-1].pth);
		}
break;
case 186:
#line 1392 "pic.y"
	{
		  lex_warning("`%1%2 last %3' in `with' argument ignored",
			      yystack.l_mark[-3].n, ordinal_postfix(yystack.l_mark[-3].n), object_type_name(yystack.l_mark[-1].obtype));
		  yyval.pth = yystack.l_mark[0].pth;
		}
break;
case 187:
#line 1398 "pic.y"
	{
		  lex_warning("`last %1' in `with' argument ignored",
			      object_type_name(yystack.l_mark[-1].obtype));
		  yyval.pth = yystack.l_mark[0].pth;
		}
break;
case 188:
#line 1404 "pic.y"
	{
		  lex_warning("`%1%2 %3' in `with' argument ignored",
			      yystack.l_mark[-2].n, ordinal_postfix(yystack.l_mark[-2].n), object_type_name(yystack.l_mark[-1].obtype));
		  yyval.pth = yystack.l_mark[0].pth;
		}
break;
case 189:
#line 1410 "pic.y"
	{
		  lex_warning("initial `%1' in `with' argument ignored", yystack.l_mark[-1].str);
		  a_delete yystack.l_mark[-1].str;
		  yyval.pth = yystack.l_mark[0].pth;
		}
break;
case 190:
#line 1419 "pic.y"
	{ yyval.crn = &object::north; }
break;
case 191:
#line 1421 "pic.y"
	{ yyval.crn = &object::east; }
break;
case 192:
#line 1423 "pic.y"
	{ yyval.crn = &object::west; }
break;
case 193:
#line 1425 "pic.y"
	{ yyval.crn = &object::south; }
break;
case 194:
#line 1427 "pic.y"
	{ yyval.crn = &object::north_east; }
break;
case 195:
#line 1429 "pic.y"
	{ yyval.crn = &object:: south_east; }
break;
case 196:
#line 1431 "pic.y"
	{ yyval.crn = &object::north_west; }
break;
case 197:
#line 1433 "pic.y"
	{ yyval.crn = &object::south_west; }
break;
case 198:
#line 1435 "pic.y"
	{ yyval.crn = &object::center; }
break;
case 199:
#line 1437 "pic.y"
	{ yyval.crn = &object::start; }
break;
case 200:
#line 1439 "pic.y"
	{ yyval.crn = &object::end; }
break;
case 201:
#line 1441 "pic.y"
	{ yyval.crn = &object::north; }
break;
case 202:
#line 1443 "pic.y"
	{ yyval.crn = &object::south; }
break;
case 203:
#line 1445 "pic.y"
	{ yyval.crn = &object::west; }
break;
case 204:
#line 1447 "pic.y"
	{ yyval.crn = &object::east; }
break;
case 205:
#line 1449 "pic.y"
	{ yyval.crn = &object::north_west; }
break;
case 206:
#line 1451 "pic.y"
	{ yyval.crn = &object::south_west; }
break;
case 207:
#line 1453 "pic.y"
	{ yyval.crn = &object::north_east; }
break;
case 208:
#line 1455 "pic.y"
	{ yyval.crn = &object::south_east; }
break;
case 209:
#line 1457 "pic.y"
	{ yyval.crn = &object::west; }
break;
case 210:
#line 1459 "pic.y"
	{ yyval.crn = &object::east; }
break;
case 211:
#line 1461 "pic.y"
	{ yyval.crn = &object::north_west; }
break;
case 212:
#line 1463 "pic.y"
	{ yyval.crn = &object::south_west; }
break;
case 213:
#line 1465 "pic.y"
	{ yyval.crn = &object::north_east; }
break;
case 214:
#line 1467 "pic.y"
	{ yyval.crn = &object::south_east; }
break;
case 215:
#line 1469 "pic.y"
	{ yyval.crn = &object::north; }
break;
case 216:
#line 1471 "pic.y"
	{ yyval.crn = &object::south; }
break;
case 217:
#line 1473 "pic.y"
	{ yyval.crn = &object::east; }
break;
case 218:
#line 1475 "pic.y"
	{ yyval.crn = &object::west; }
break;
case 219:
#line 1477 "pic.y"
	{ yyval.crn = &object::center; }
break;
case 220:
#line 1479 "pic.y"
	{ yyval.crn = &object::start; }
break;
case 221:
#line 1481 "pic.y"
	{ yyval.crn = &object::end; }
break;
case 222:
#line 1486 "pic.y"
	{ yyval.x = yystack.l_mark[0].x; }
break;
case 223:
#line 1488 "pic.y"
	{ yyval.x = yystack.l_mark[0].x; }
break;
case 224:
#line 1493 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x < yystack.l_mark[0].x); }
break;
case 225:
#line 1498 "pic.y"
	{
		  if (!lookup_variable(yystack.l_mark[0].str, & yyval.x)) {
		    lex_error("there is no variable `%1'", yystack.l_mark[0].str);
		    YYABORT;
		  }
		  a_delete yystack.l_mark[0].str;
		}
break;
case 226:
#line 1506 "pic.y"
	{ yyval.x = yystack.l_mark[0].x; }
break;
case 227:
#line 1508 "pic.y"
	{
		  if (yystack.l_mark[-1].pl.obj != 0)
		    yyval.x = yystack.l_mark[-1].pl.obj->origin().x;
		  else
		    yyval.x = yystack.l_mark[-1].pl.x;
		}
break;
case 228:
#line 1515 "pic.y"
	{
		  if (yystack.l_mark[-1].pl.obj != 0)
		    yyval.x = yystack.l_mark[-1].pl.obj->origin().y;
		  else
		    yyval.x = yystack.l_mark[-1].pl.y;
		}
break;
case 229:
#line 1522 "pic.y"
	{
		  if (yystack.l_mark[-1].pl.obj != 0)
		    yyval.x = yystack.l_mark[-1].pl.obj->height();
		  else
		    yyval.x = 0.0;
		}
break;
case 230:
#line 1529 "pic.y"
	{
		  if (yystack.l_mark[-1].pl.obj != 0)
		    yyval.x = yystack.l_mark[-1].pl.obj->width();
		  else
		    yyval.x = 0.0;
		}
break;
case 231:
#line 1536 "pic.y"
	{
		  if (yystack.l_mark[-1].pl.obj != 0)
		    yyval.x = yystack.l_mark[-1].pl.obj->radius();
		  else
		    yyval.x = 0.0;
		}
break;
case 232:
#line 1543 "pic.y"
	{ yyval.x = yystack.l_mark[-2].x + yystack.l_mark[0].x; }
break;
case 233:
#line 1545 "pic.y"
	{ yyval.x = yystack.l_mark[-2].x - yystack.l_mark[0].x; }
break;
case 234:
#line 1547 "pic.y"
	{ yyval.x = yystack.l_mark[-2].x * yystack.l_mark[0].x; }
break;
case 235:
#line 1549 "pic.y"
	{
		  if (yystack.l_mark[0].x == 0.0) {
		    lex_error("division by zero");
		    YYABORT;
		  }
		  yyval.x = yystack.l_mark[-2].x/yystack.l_mark[0].x;
		}
break;
case 236:
#line 1557 "pic.y"
	{
		  if (yystack.l_mark[0].x == 0.0) {
		    lex_error("modulus by zero");
		    YYABORT;
		  }
		  yyval.x = fmod(yystack.l_mark[-2].x, yystack.l_mark[0].x);
		}
break;
case 237:
#line 1565 "pic.y"
	{
		  errno = 0;
		  yyval.x = pow(yystack.l_mark[-2].x, yystack.l_mark[0].x);
		  if (errno == EDOM) {
		    lex_error("arguments to `^' operator out of domain");
		    YYABORT;
		  }
		  if (errno == ERANGE) {
		    lex_error("result of `^' operator out of range");
		    YYABORT;
		  }
		}
break;
case 238:
#line 1578 "pic.y"
	{ yyval.x = -yystack.l_mark[0].x; }
break;
case 239:
#line 1580 "pic.y"
	{ yyval.x = yystack.l_mark[-1].x; }
break;
case 240:
#line 1582 "pic.y"
	{
		  errno = 0;
		  yyval.x = sin(yystack.l_mark[-1].x);
		  if (errno == ERANGE) {
		    lex_error("sin result out of range");
		    YYABORT;
		  }
		}
break;
case 241:
#line 1591 "pic.y"
	{
		  errno = 0;
		  yyval.x = cos(yystack.l_mark[-1].x);
		  if (errno == ERANGE) {
		    lex_error("cos result out of range");
		    YYABORT;
		  }
		}
break;
case 242:
#line 1600 "pic.y"
	{
		  errno = 0;
		  yyval.x = atan2(yystack.l_mark[-3].x, yystack.l_mark[-1].x);
		  if (errno == EDOM) {
		    lex_error("atan2 argument out of domain");
		    YYABORT;
		  }
		  if (errno == ERANGE) {
		    lex_error("atan2 result out of range");
		    YYABORT;
		  }
		}
break;
case 243:
#line 1613 "pic.y"
	{
		  errno = 0;
		  yyval.x = log10(yystack.l_mark[-1].x);
		  if (errno == ERANGE) {
		    lex_error("log result out of range");
		    YYABORT;
		  }
		}
break;
case 244:
#line 1622 "pic.y"
	{
		  errno = 0;
		  yyval.x = pow(10.0, yystack.l_mark[-1].x);
		  if (errno == ERANGE) {
		    lex_error("exp result out of range");
		    YYABORT;
		  }
		}
break;
case 245:
#line 1631 "pic.y"
	{
		  errno = 0;
		  yyval.x = sqrt(yystack.l_mark[-1].x);
		  if (errno == EDOM) {
		    lex_error("sqrt argument out of domain");
		    YYABORT;
		  }
		}
break;
case 246:
#line 1640 "pic.y"
	{ yyval.x = yystack.l_mark[-3].x > yystack.l_mark[-1].x ? yystack.l_mark[-3].x : yystack.l_mark[-1].x; }
break;
case 247:
#line 1642 "pic.y"
	{ yyval.x = yystack.l_mark[-3].x < yystack.l_mark[-1].x ? yystack.l_mark[-3].x : yystack.l_mark[-1].x; }
break;
case 248:
#line 1644 "pic.y"
	{ yyval.x = yystack.l_mark[-1].x < 0 ? -floor(-yystack.l_mark[-1].x) : floor(yystack.l_mark[-1].x); }
break;
case 249:
#line 1646 "pic.y"
	{ yyval.x = 1.0 + floor(((rand()&0x7fff)/double(0x7fff))*yystack.l_mark[-1].x); }
break;
case 250:
#line 1648 "pic.y"
	{
		  /* return a random number in the range [0,1) */
		  /* portable, but not very random */
		  yyval.x = (rand() & 0x7fff) / double(0x8000);
		}
break;
case 251:
#line 1654 "pic.y"
	{
		  yyval.x = 0;
		  srand((unsigned int)yystack.l_mark[-1].x);
		}
break;
case 252:
#line 1659 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x <= yystack.l_mark[0].x); }
break;
case 253:
#line 1661 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x > yystack.l_mark[0].x); }
break;
case 254:
#line 1663 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x >= yystack.l_mark[0].x); }
break;
case 255:
#line 1665 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x == yystack.l_mark[0].x); }
break;
case 256:
#line 1667 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != yystack.l_mark[0].x); }
break;
case 257:
#line 1669 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 && yystack.l_mark[0].x != 0.0); }
break;
case 258:
#line 1671 "pic.y"
	{ yyval.x = (yystack.l_mark[-2].x != 0.0 || yystack.l_mark[0].x != 0.0); }
break;
case 259:
#line 1673 "pic.y"
	{ yyval.x = (yystack.l_mark[0].x == 0.0); }
break;
#line 5982 "pic.cpp"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
